﻿let CHROME_ID = ""
let CHROME_COLOR = "linear-gradient(to right, #e24e5d, #ff6644)"
let PRO_PAGE = 2;
let THIS_PAGE = "";
let YZ_USER = [];
let YZ_SIZEPAGE = 28;
//评论asin分析数据
let YZ_THSTASIN = [];
//评论数据
let YZ_REVIEWDATA = [];
//商品数据
let YZ_PRODATA = [];
//筛选后的商品数据
let YZ_PRODATA_FILTER = [];

//评论分析星级图1
let echarts_1_list = [[], []];
//评论分析星级图2
let echarts_2_list = [];
//评论分析星级图3
let echarts_3_list = {data1:[],data2:[],name:[]};

let insertThisAsin = '';
let insertDataAsinHTML = '';
let selectTypeDataHTML = '';
let reviewParticipleHTML = '';
//过滤后的评论数据
let YZ_REVIEWDATA_FILTER = [];
//评论分析显示多少页
let YZ_PAGECOUNT;
//评论每页显示的数据
let YZ_REVIEWDATA_RENDER = [];
let RENDER_P = 1;
//页数按钮
let asAll;
//抓取结果	
var result = []
//限制商品最大页数评论
var MAX_PAGE = 10;
var PAGE = 0;
var total = 0;
var process = 0;
//评论分析评论图表
var tbodyList = [];
//请求的标识
var uuid = "";

let YZ_HTTP = "https://www.vmapg.com/api/";

//获取id
chrome.extension.sendMessage({ type: 'getChromeId' }, function (res) {
	CHROME_ID = res.chromeId;
	// console.log(CHROME_ID);
});

//全屏功能
function fullScreen (page) {
	//进行切换
	var fullScreenClickCount = true;
	//调用各个浏览器提供的全屏方法
	var handleFullScreen = function () {
		if (page.requestFullscreen) {
			page.requestFullscreen();
		} else if (page.mozRequestFullScreen) {
			page.mozRequestFullScreen();
		} else if (page.webkitRequestFullScreen) {
			page.webkitRequestFullScreen();
		} else if (page.msRequestFullscreen) {
			page.msRequestFullscreen();
		}
		else {
			wtx.info("当前浏览器不支持全屏！");
		}
	};
	//调用各个浏览器提供的退出全屏方法
	var exitFullscreen = function () {
		if (document.exitFullscreen) {
			document.exitFullscreen();
		} else if (document.mozCancelFullScreen) {
			document.mozCancelFullScreen();
		} else if (document.webkitExitFullscreen) {
			document.webkitExitFullscreen();
		}
		if ($('#review-page').length) {
			$('#review-page').css({ "top": "50%", "left": "50%", "transform": "translate(-50%, -50%)" });
		}
	}
	document.getElementById("fullScreen").addEventListener('click', function () {
		if (fullScreenClickCount) {
			handleFullScreen();
			$('.shrink').show().siblings().hide();
			fullScreenClickCount = false;
		} else {
			exitFullscreen();
			$('.magnify').show().siblings().hide();
			fullScreenClickCount = true;
		}
	}, false)
}

// 注意，必须设置了run_at=document_start 此段代码才会生效
document.addEventListener('DOMContentLoaded', function () {
	if (location.host == 'www.amazon.com') {
		var centerCol = document.getElementById("title_feature_div");
		if (centerCol != null) {
			var reviewDivF = document.createElement("div");
			reviewDivF.id = "YZ-revDIV";
			$(centerCol).after(reviewDivF)
			var div = document.getElementById("YZ-revDIV")

			var reviewDiv = document.createElement("div");
			reviewDiv.id = "submit.review-now1";
			reviewDiv.className = "revanalysis";
			reviewDiv.style.background = CHROME_COLOR;
			reviewDiv.textContent = "评论下载";
			div.appendChild(reviewDiv);

			var reviewDiv_1 = document.createElement("div");
			reviewDiv_1.id = "submit.review-now2";
			reviewDiv_1.className = "revanalysis";
			reviewDiv_1.style.background = CHROME_COLOR;
			reviewDiv_1.textContent = "评论分析";
			div.appendChild(reviewDiv_1)

			document.getElementById("submit.review-now1").addEventListener('click', function () {
				chrome.runtime.sendMessage({ type: "islogin" }, function (response) {
					if (response.isLogin == "0") {
						$('#signinDiv').css("display", "block");
					} else {
						var linkReviewsUrl = $($("[data-hook='see-all-reviews-link-foot']")[0]).attr("href").split('ref')[0] + "/ref=cm_cr_arp_d_viewopt_srt?ie=UTF8&reviewerType=all_reviews&sortBy=recent&pageNumber=1";
						PAGE = 0;
						if (linkReviewsUrl) {
							sendDownloadMsg(linkReviewsUrl, reviewDiv);
						}
					}
				});
			}, false);
			document.getElementById("submit.review-now2").addEventListener('click', function () {
				chrome.runtime.sendMessage({ type: "islogin" }, function (response) {
					if (response.isLogin == "0") {
						$('#signinDiv').css("display", "block");
					} else {
						tbodyList.length = 0;
						var linkReviewsUrl = $($("[data-hook='see-all-reviews-link-foot']")[0]).attr("href").split('ref')[0] + "/ref=cm_cr_arp_d_viewopt_srt?ie=UTF8&reviewerType=all_reviews&sortBy=recent&pageNumber=1";
						var t = `
				<div class=mask>
					<div class=login-page id="review-page" >
						<div class="s-move-content-header" id="s-move-content-header">
							<button id="fullScreen" class="btn_2">
								<span class="iconfont magnify">&#xe6a7;</span>
								<span class="iconfont shrink" style="display:none;">&#xe7af;</span>
							</button>
							<button id="YZ-hide"  class="btn_1" ></button>
						</div>

						<div class="s-move-content-body">
							<div class="bodyAll">
								<div class="body_a">
									<div class="card fz13 body_a_header">
										<div class="card-body" id=YZ-headerData>
											<img class=YZ-imgLoad src="chrome-extension://`+ CHROME_ID + `/image/jiazai.gif" style="width: 200px;height: 100px;position: relative;left: 50%;transform: translateX(-50%);">
										</div>
									</div>
									<div class="card body_a_body">
										<div>
											<table style="table-layout:fixed;width: auto">
												<colgroup>
													<col name="body_a_column_1" style="width: 50px;text-align:center;"></col>
													<col name="body_a_column_2" style="width: 70px"></col>
													<col name="body_a_column_3" style="width: 120px"></col>
													<col name="body_a_column_4" style="width: 100px"></col>
													<col name="body_a_column_5" style="width: 120px"></col>
													<col name="body_a_column_6" style="width: 300px"></col>
													<col name="body_a_column_7" style="width: 80px"></col>
													<col name="body_a_column_8" style="width: 80px"></col>
													<col name="body_a_column_9" style="width: 80px"></col>
													<col name="body_a_column_10" style="width: 100px"></col>
													<col name="body_a_column_11" style="width: 80px"></col>
													<col name="body_a_column_12" style="width: 120px"></col>
												</colgroup>
												<thead>
													<tr class="tth" style="height:40px;line-height:40px;">
														<th colspan="1" rowspan="1" class="body_a_column_1"  style="text-align:center;">#</th>
														<th colspan="1" rowspan="1" class="body_a_column_2" style="text-align:center;">图片</th>
														<th colspan="1" rowspan="1" class="body_a_column_3">asin</th>
														<th colspan="1" rowspan="1" class="body_a_column_4">BSR</th>
														<th colspan="1" rowspan="1" class="body_a_column_5">价格</th>
														<th colspan="1" rowspan="1" class="body_a_column_6">型号</th>
														<th colspan="1" rowspan="1" class="body_a_column_7">评分数</th>
														<th colspan="1" rowspan="1" class="body_a_column_8">评分星级</th>
					
														<th colspan="1" rowspan="1" class="body_a_column_10">评论数占比</th>
														<th colspan="1" rowspan="1" class="body_a_column_11">卖家数</th>
														<th colspan="1" rowspan="1" class="body_a_column_12">上架时间</th>
										
													</tr>
												</thead>
											</table>
										</div>
										<div>
											<table style="table-layout: fixed;width: auto">
												<colgroup>
													<col name="body_a_column_1" style="width: 50px;"></col>
													<col name="body_a_column_2" style="width: 70px"></col>
													<col name="body_a_column_3" style="width: 120px"></col>
													<col name="body_a_column_4" style="width: 100px"></col>
													<col name="body_a_column_5" style="width: 120px"></col>
													<col name="body_a_column_6" style="width: 300px"></col>
													<col name="body_a_column_7" style="width: 80px"></col>
													<col name="body_a_column_8" style="width: 80px"></col>
													<col name="body_a_column_9" style="width: 80px"></col>
													<col name="body_a_column_10" style="width: 100px"></col>
													<col name="body_a_column_11" style="width: 80px"></col>
													<col name="body_a_column_12" style="width: 120px"></col>
												</colgroup>
												<tbody id=YZ-asinVariationsData>
													<img id=YZ-imgLoad src="chrome-extension://`+ CHROME_ID + `/image/jiazai.gif" style="width: 441px;height: 291px;position: relative;left: 50%;transform: translateX(-50%);">
												</tbody>
											</table>
										</div>
									</div>
									

								</div>
								<div class="body_b">
									<div class="card">
									 	<div>
									 		<div id="body_b_echarts1" style="width:800px;height:300px"></div>
									 		<div id="body_b_echarts2" style="width:500px;height:300px"></div>
									 	</div>
									</div>
								</div>
							
								<div class="body_e" style="">
									<div style="display: flex;	flex-wrap: wrap;flex: 1;justify-content: flex-start;align-items: center;" id="reviewParticiple">

									</div>
									<div class="YZ-proAnaDiv card">
										<div>
										<!--筛选栏下拉-->
										<div class="select" style="width:250px;">
											<!--存放选择的值-->
											<span class="selectVal" id=reviewsDatatype onselectstart="return false">-评论类型-</span>
											<!--放置icon-->
											<i class="xl-icon" style="background-image: url(chrome-extension://`+ CHROME_ID + `/image/xl-icon.png);"></i>
											<!--选择项-->
											<div class="selectList">
												<div id=selectReviewsTypeData class="listA-all">
												<a class="listA">全部</a>
												</div>
											</div>
										</div>
										<!--筛选栏下拉end-->
										<!--日期排序-->
										<div class="select">
											<span class="selectVal" id=reviewsDataDate onselectstart="return false">-评论时间排序-</span>
											<i class="xl-icon" style="background-image: url(chrome-extension://`+ CHROME_ID + `/image/xl-icon.png);"></i>
											<div class="selectList">
												<div class="listA-all">
														<a href="javascript:;" class="listA">评论时间降序</a>
														<a href="javascript:;" class="listA">评论时间升序</a>
												</div>
											</div>
										</div>
											<!--日期排序end-->
											<!--日期选择-->
											<div class="timesection">
												<div>
													<div class="c-datepicker-date-editor  J-datepicker-range-day">
														<i class="c-datepicker-range__icon kxiconfont icon-clock"></i>
														<input placeholder="开始日期" name="" id=beginDate class="c-datepicker-data-input only-date" value="">
														<span class="c-datepicker-range-separator">-</span>
														<input placeholder="结束日期" name=""  id=endDate class="c-datepicker-data-input only-date" value="">
													</div>
												</div>
											</div>
											<script>
											$(function(){
												var DATAPICKERAPI = {
													// 快捷选项option
													rangeShortcutOption1: [{
														name: '最近一周',
														day: '-7,0'
													}, {
														name: '最近一个月',
														day: '-30,0'
													}, {
														name: '最近三个月',
														day: '-90, 0'
													}],
													singleShortcutOptions1: [{
														name: '今天',
														day: '0',
														time: '00:00:00'
													}, {
														name: '昨天',
														day: '-1',
														time: '00:00:00'
													}, {
														name: '一周前',
														day: '-7'
													}]
												};
												
												//年月日范围
												$('.J-datepicker-range-day').datePicker({
													hasShortcut: true,
													format: 'YYYY-MM-DD',
													isRange: true,
													shortcutOptions: DATAPICKERAPI.rangeShortcutOption1
												});
								
											});
											</script>
											<!--日期选择end-->
											<div class="ml5" style="display:inline-block;">
												<input type="checkbox" value="1.0 颗星，最多 5 颗星" name="YZ-hobby" id="YZ-checkbox1"/><label for="YZ-checkbox1" class="YZ-proAnaDiv-checkbox">一星</label>
												<input type="checkbox" value="2.0 颗星，最多 5 颗星" name="YZ-hobby" id="YZ-checkbox2"/><label for="YZ-checkbox2" class="YZ-proAnaDiv-checkbox">二星</label>
												<input type="checkbox" value="3.0 颗星，最多 5 颗星" name="YZ-hobby" id="YZ-checkbox3"/><label for="YZ-checkbox3" class="YZ-proAnaDiv-checkbox">三星</label>
												<input type="checkbox" value="4.0 颗星，最多 5 颗星" name="YZ-hobby" id="YZ-checkbox4"/><label for="YZ-checkbox4" class="YZ-proAnaDiv-checkbox">四星</label>
												<input type="checkbox" value="5.0 颗星，最多 5 颗星" name="YZ-hobby" id="YZ-checkbox5"/><label for="YZ-checkbox5" class="YZ-proAnaDiv-checkbox">五星</label>
											</div>
											<div class="antistop-container">
												<input type="text" placeholder="请输入关键词" name=YZ_field-keywords autocomplete="off" ></input>
												<div>
													<ul></ul>
												</div>
											</div>
											<input type="button" value="查找" id=YZ-findAll class="YZ-findAll"/>
										</div>
										<div class="YZ-proAnaDiv-div" id=YZ-proAnaComm style=""></div>
										<div class="YZ-pagination-container">
												<!--
												<span class="YZ-page-change YZ-prev"><i class="arrow2"></i>上一页</span>
												<div class="YZ-pagination"> </div>
												<span class="YZ-page-change YZ-next">下一页<i class="arrow3"></i></span>
												-->
										</div>
									</div>
								</div>
							</div>
						</div>

						<div class="s-move-content-footer" id="s-move-content-footer">
							<!--
							<ul id="footer-option">
								<li class="ml10 active ">首页</li>
								<li class="ml10">详情页</li>
							</ul>
							-->
						</div>
					</div>
				</div>
				`;

						$('#showDiv').html(t);
						if (!YZ_REVIEWDATA.length) {
							getRevAnalysis(linkReviewsUrl, null, 1)
						} else {
							$('#YZ-imgLoad').remove();
							$('.YZ-imgLoad').remove();
							$('#YZ-headerData').html(insertThisAsin)
							$('#YZ-asinVariationsData').html(insertDataAsinHTML)
							$('#selectReviewsTypeData').html(selectTypeDataHTML);
							$('#reviewParticiple').html(reviewParticipleHTML)
							reviewsDataTypeJs()
							//星级图
							echarts_1()
							echarts_2()
							//
							YZ_REVIEWDATA_FILTER = YZ_REVIEWDATA;
							YZ_PAGECOUNT = Math.ceil(YZ_REVIEWDATA_FILTER.length / 20)
							$(".YZ-pagination-container").createPage({
								pageCount: YZ_PAGECOUNT,
								current: 1,
								backFn: function (p) {
									RENDER_P = p
									render();//重新渲染
								},
							});
							render();
						}

						document.getElementById("s-move-content-header").addEventListener("mousedown", function (event) {
							var rPage = document.getElementById("review-page");
							let y = event.pageY - rPage.offsetTop;
							let x = event.pageX - rPage.offsetLeft;
							// 可document.getElementById("s-move-content-header")可document
							document.addEventListener("mousemove", move, false)
							function move (event) {
								rPage.style.left = event.pageX - x + 'px';
								rPage.style.top = event.pageY - y + 'px';
							}
							document.addEventListener("mouseup", function () {
								document.removeEventListener("mousemove", move, false)
							}, false);
						}, false);

						document.getElementById("YZ-hide").addEventListener('click', function () {
							$('.mask').hide();
						}, false);
						var reviewPage = document.getElementById('review-page');
						fullScreen(reviewPage);

						document.getElementById("YZ-findAll").onclick = function () {
							var date = document.getElementsByName("YZ-hobby");
							var str = [];
							for (var i = 0; i < date.length; i++) {
								if (date[i].checked == true) {
									str.push(date[i].value);
								}
							}
							YZ_proAnaComm_div = '';
							RENDER_P = 1

							var beginDate = $('#beginDate').val();
							var endDate = $('#endDate').val();
							var reviewsDatatype = $('#reviewsDatatype').text();
							var reviewsDataDate = $('#reviewsDataDate').text();
							var fieldKeywords = $("[name='YZ_field-keywords']").val();
							findReviewsData(str, beginDate, endDate, reviewsDataDate, reviewsDatatype, fieldKeywords)
						}
					}
				});
			}, false);

		}
	}
});

function reviewsDataTypeJs () {
	// 下拉列表
	//外层select框
	var oDropDown = $('.select');
	//选择列表项
	var oChangeA = $('.listA');
	oDropDown.click(function () {
		$(this).find('.selectList').toggle().siblings('.xl-icon').toggleClass('sq-icon');
	});
	oDropDown.mouseleave(function () {
		$(this).find('.selectList').hide().siblings('.xl-icon').removeClass('sq-icon');
	});
	oChangeA.click(function () {
		var oVal = $(this).text();
		$(this).parents('.listA-all').parents('.selectList').siblings('.selectVal').text(oVal).siblings('.xl-icon').toggleClass('sq-icon');
	});
}

function echarts_1 () {
	var myChart = echarts.init(document.querySelector('#body_b_echarts1'));
	var option = {
		title: {
			text: '评论星级占比数据',
			padding: [10, 20]
		},
		xAxis: {
			type: 'value',
			show: false
		},
		yAxis: {
			type: 'category',
			axisLine: {     //y轴坐标轴
				show: false,
			},
			axisTick: {
				show: false
			},
			axisLabel: {
				fontSize: 16
			},
			data: echarts_1_list[0]
			// ['一星', '二星', '三星', '四星', '五星']
		},
		series: [
			{
				data: echarts_1_list[1],
				// [120, 200, 150, 80, 70,]
				type: 'bar',
				showBackground: true,
				backgroundStyle: {
					color: 'rgba(180, 180, 180, 0.2)'
				},
				label: {
					show: true, //开启显示
					position: 'right', //在上方显示
					textStyle: { //数值样式
						color: 'black',
						fontSize: 20
					}
				}
			}
		]
	};
	myChart.setOption(option);
}
function echarts_2 () {
	var myChart = echarts.init(document.querySelector('#body_b_echarts2'));
	var option = {
		tooltip: {
			trigger: 'item'
		},
		series: [
			{
				name: '评分星级条数',
				type: 'pie',
				radius: '50%',
				label: {
					formatter: '{b} ( {d}% )'// 显示百分比，
				},
				data: echarts_2_list,
				emphasis: {
					itemStyle: {
						shadowBlur: 10,
						shadowOffsetX: 0,
						shadowColor: 'rgba(0, 0, 0, 0.5)'
					}
				}
			}
		]
	};
	myChart.setOption(option);
}
function echarts_3 () {
	  // 基于准备好的dom，初始化echarts实例
		var myChart = echarts.init(document.querySelector('#body_b_echarts1'));
		// var data = [70, 34, 60, 78, 69];
		var data = echarts_3_list.data2;
		// var titlename = ["HTML5", "CSS3", "javascript", "VUE", "NODE"];
		var titlename = echarts_3_list.name;
		// var valdata = [702, 350, 610, 793, 664];
		var valdata = echarts_3_list.data1;
		var myColor = ["#1089E7", "#F57474", "#56D0E3", "#F8B448", "#8B78F6"];
		option = {
			//图标位置
			grid: {
				top: "10%",
				left: "22%",
				bottom: "10%"
			},
			xAxis: {
				show: false
			},
			yAxis: [
				{
					show: true,
					data: titlename,
					inverse: true,
					axisLine: {
						show: false
					},
					splitLine: {
						show: false
					},
					axisTick: {
						show: false
					},
					axisLabel: {
						color: "#fff",
	
						rich: {
							lg: {
								backgroundColor: "#339911",
								color: "#fff",
								borderRadius: 15,
								// padding: 5,
								align: "center",
								width: 15,
								height: 15
							}
						}
					}
				},
				{
					show: true,
					inverse: true,
					data: valdata,
					axisLabel: {
						textStyle: {
							fontSize: 12,
							color: "#fff"
						}
					}
				}
			],
			series: [
				{
					name: "条",
					type: "bar",
					yAxisIndex: 0,
					data: data,
					barCategoryGap: 50,
					barWidth: 10,
					itemStyle: {
						normal: {
							barBorderRadius: 20,
							color: function(params) {
								var num = myColor.length;
								return myColor[params.dataIndex % num];
							}
						}
					},
					label: {
						normal: {
							show: true,
							position: "inside",
							formatter: "{c}%"
						}
					}
				},
				{
					name: "框",
					type: "bar",
					yAxisIndex: 1,
					barCategoryGap: 50,
					data: [100, 100, 100, 100, 100],
					barWidth: 15,
					itemStyle: {
						normal: {
							color: "none",
							borderColor: "#00c1de",
							borderWidth: 3,
							barBorderRadius: 15
						}
					}
				}
			]
		};
	
		// 使用刚指定的配置项和数据显示图表。
		myChart.setOption(option);
		window.addEventListener("resize", function() {
			myChart.resize();
		});
}

var YZ_proAnaComm_div = '';
var proimgThis = '';
var proNameThis = "";
var proreviewAgeThis = "";
var reviewParticiple = [];
function getRevAnalysis (url, str, pageNum) {
	var subMsg = url.substr(url.indexOf('product-reviews') + 'product-reviews'.length + 1);
	var asin = subMsg.substr(0, subMsg.indexOf('/'));
	if (pageNum == 1) {
		var url = "https://www.amazon.com/-/zh/product-reviews/" + asin + "/ref=cm_cr_arp_d_viewopt_srt?ie=UTF8&reviewerType=all_reviews&sortBy=recent&pageNumber=1";
	}
	$.ajax({
		type: "GET",
		url: url,
		success: function (html) {
			var reviewDoc = $(html);
			if (pageNum == 1) {
				proimgThis = reviewDoc.find("[class='a-text-center a-spacing-top-micro a-fixed-left-grid-col product-image a-col-left']");
				proimgThis = $(proimgThis).find("img").attr('src');
				proNameThis = reviewDoc.find("[data-hook='product-link']")[0].innerText;
				proreviewAgeThis = reviewDoc.find("[data-hook='average-star-rating']")[0].innerText.split(" ")[0];
			}
			var reviewDiv = reviewDoc.find("[data-hook='review']");
			let reviewBodyList = new Array();
			getRevAnalysisInfo();
			function getRevAnalysisInfo () {
				reviewDiv.each(function (i, r) {
					reviews = {};
					reviewsData = {};
					//评论人
					var profileName = $(r).find(".a-profile-name")[0].innerText;
					reviewsData["profileName"] = profileName;
					//获取评分
					var reviewStar = $(r).find(".a-icon-alt")[0].innerText;
					reviewsData["reviewStar"] = reviewStar;
					reviews["reviewStarSum"] = parseFloat(reviewStar.split(" ")[0].trim());
					reviews["num"] = 1;
					//评论标题
					var reviewTitle = $(r).find("[data-hook='review-title']")[0].innerText.trim();
					reviewsData["reviewTitle"] = reviewTitle;
					//获取评论地址和日期，后面在拆分
					var rDate = $(r).find("[data-hook='review-date']");
					var reviewDate = rDate[0].innerText.split(' ')[0];
					reviewsData["reviewDate"] = reviewDate;
					var reviewIP = rDate[0].innerText.split(' ')[1];
					reviewsData["reviewIP"] = reviewIP;
					//获取评论颜色
					var rColor = $(r).find("[data-hook='format-strip']");
					var reviewColor = '';
					reviews["asinType"] = "/";
					if (rColor.length > 0) {
						reviewColor = rColor[0].innerText;
						reviews["asin"] = rColor.attr('href').split('/')[4];
						if (reviews.asin == "" || reviews.asin == null) {
							reviews.asin = rColor.attr('href').split('/')[2]
						}
						reviews["asinType"] = reviewColor;//asin类型
						reviewsData["asinType"] = reviewColor;
						var thisASIN = YZ_THSTASIN.filter(function (r) {
							return r.asin == reviews.asin;
						})
						if (thisASIN.length > 0) {
							thisASIN[0]["num"] = thisASIN[0]["num"] + 1;
							thisASIN[0]["reviewStarSum"] = thisASIN[0]["reviewStarSum"] + reviews.reviewStarSum;
						} else {
							asinDetail(reviews);
							YZ_THSTASIN.push(reviews)
						}
					} else {
						reviews["asin"] = asin;
						var thisASIN = YZ_THSTASIN.filter(function (r) {
							return r.asin == asin;
						})
						if (thisASIN.length > 0) {
							thisASIN[0]["num"] = thisASIN[0]["num"] + 1;
							thisASIN[0]["reviewStarSum"] = thisASIN[0]["reviewStarSum"] + reviews.reviewStarSum;
						} else {
							asinDetail(reviews);
							YZ_THSTASIN.push(reviews)
						}
					}
					//获取评论内容
					var rBody = $(r).find("[data-hook='review-body']");
					var reviewBody = rBody[0].innerText;
					reviewsData["reviewBody"] = reviewBody;
					reviewBodyList.push(reviewBody.trim());
					var rHelpful = $(r).find("[data-hook='helpful-vote-statement']");
					if (rHelpful.length > 0)
						helpfulText = rHelpful[0].innerText.trim();
					else
						helpfulText = "";
					// 星星数量
					var reviewStarNum = "";
					for (var i = 0; i < reviewStar.substr(0, 1); i++) {
						reviewStarNum += '<img src="chrome-extension://' + CHROME_ID + '/image/star-on-big.png">'
					}
					for (var i = 5; i > reviewStar.substr(0, 1); i--) {
						reviewStarNum += '<img src="chrome-extension://' + CHROME_ID + '/image/star-off-big.png">'
					}
					YZ_proAnaComm_div += '<div class=YZ-proComm>' +
						'<div><span>' + reviewTitle + '</span></div>' +
						'<div>' + reviewStarNum + '<span style="font-weight:500;vertical-align: middle;">  ' + profileName + '</span></div>' +
						'<div><span>' + reviewDate + " " + reviewIP + '</span></div>' +
						'<div>' + reviewBody + '</div>' +
						'</div>';
					if (pageNum <= 5) {
						$('#YZ-proAnaComm').html(YZ_proAnaComm_div)
					}
					YZ_REVIEWDATA.push(reviewsData)
				})
			}
			var reviewsSum = 0;
			var reviewsAge = 0;
			// var echarts_1_list = [[], []];
			// var echarts_2_list = [];
			if (pageNum == 1) {
				var rSumT = reviewDoc.find("[data-hook='total-review-count']");
				var rSum = 0;
				if (rSumT.length > 0) {
					rSum = new Number(rSumT[0].innerText.trim().split(' ')[0].replace(/,/g, ""));
				}
				var revTable = reviewDoc.find("[id='histogramTable'] tr");
				// var rTr = "";
				// 统计评论总数
				var reviewsAll = 0;
				revTable.each(function (i, r) {
					var base = $(r).find('[class="a-size-base"]')[0].innerText.trim();
					var now = $(r).find('[class="a-text-right a-nowrap"]')[0].innerText.trim();
					var sun = new Number(now.replace(/%/g, ""))
					var sum = Math.ceil(rSum * (sun / 100));
					// rTr = rTr + '<tr><td>' + base + '</td><td>' + sum + '</td><td>' + now + '</td></tr>';
					if (i == 1) {
						reviewsSum = sum;
						reviewsAge = now;
					}
					// $('#tbodydata').html(rTr)
					// 星级图一数据
					echarts_1_list[0].push(base)
					echarts_1_list[1].push(sum)
					// 星级图二数据
					var obj = {};
					obj.value = sum;
					obj.name = base;
					echarts_2_list.push(obj)
					// 星级图三数据
					echarts_3_list.data1.push(sum)
					echarts_3_list.name.push(base)
					reviewsAll+=sum
				})
				echarts_3_list.data2 = echarts_3_list.data1.map( item => {
					return parseInt((item/reviewsAll)*100)
				})
				// 星级图表
				echarts_1()
				echarts_2()
			}

			var has = $(html).find("[data-hook='pagination-bar']")
			//i<5 限制只获取5页评论
			if (has.length > 0) {
				var hasNext = $(has[0]).find(".a-last");
				if (hasNext.length > 0) {
					var nextUrl = $(hasNext[0]).find('a').attr("href");
					let reviewObj = {};
					reviewObj["reviewBodyList"] = reviewBodyList;
					if (nextUrl) {
						reviewObj["end"] = false;
						getRevAnalysis(nextUrl, null, pageNum + 1)
					} else {
						setTimeout(function () {
							insertDataAsin(YZ_THSTASIN, asin, reviewsSum, reviewsAge,reviewParticiple);
							reviewParticiple = [];
							YZ_THSTASIN = [];
						}, 4000);
						reviewObj["end"] = true;
					}
					chrome.runtime.sendMessage({ review: reviewObj, type: "reviewParticiple" }, function (response) {
						if (response.msg != 0) {
							reviewParticiple = response;
						}
					});

				} else {
					setTimeout(function () {
						insertDataAsin(YZ_THSTASIN, asin, reviewsSum, reviewsAge,reviewParticiple);
						reviewParticiple = [];
						YZ_THSTASIN = [];
					}, 4000);
				}
			} else {
				setTimeout(function () {
					insertDataAsin(YZ_THSTASIN, asin, reviewsSum, reviewsAge,reviewParticiple);
					reviewParticiple = [];
					YZ_THSTASIN = [];
				}, 4000);
			}
		},
		complete: function () {
			YZ_REVIEWDATA_FILTER = YZ_REVIEWDATA;
			YZ_PAGECOUNT = Math.ceil(YZ_REVIEWDATA_FILTER.length / 20)

			if (YZ_REVIEWDATA.length) {
				YZ_REVIEWDATA_FILTER = YZ_REVIEWDATA;
				YZ_PAGECOUNT = Math.ceil(YZ_REVIEWDATA_FILTER.length / 20)
				$(".YZ-pagination-container").createPage({
					pageCount: YZ_PAGECOUNT,
					current: RENDER_P,
					backFn: function (p) {
						// console.log('此乃全部渲染');
						RENDER_P = p
						render();//重新渲染
					},
				});
				if (YZ_PAGECOUNT < 3) {
					render();
				}
			}
		}
	})
}

//根据条件显示评论
function findReviewsData (str, beginDate, endDate, reviewsDataDate, reviewsDatatype, fieldKeywords) {
	YZ_REVIEWDATA_FILTER = JSON.parse(JSON.stringify(YZ_REVIEWDATA));

	YZ_REVIEWDATA_FILTER = YZ_REVIEWDATA_FILTER.filter(function (r) {
		var b = true;
		if (str != null && str != "") {
			var srcdata = str.filter(function (s) {
				return s == r.reviewStar;
			})
			if (srcdata != r.reviewStar) {
				b = false;
				return b;
			}
		}
		if (beginDate != null && beginDate != "") {
			beginDate = dislodgeZero(beginDate);
			if (!(new Date(beginDate).getTime() <= new Date(Date.parse(r.reviewDate.replace('年', '-').replace('月', '-').replace('日', ''))).getTime())) {
				b = false;
				return b;
			}
		}
		if (endDate != null && endDate != '') {
			endDate = dislodgeZero(endDate);
			if (!(new Date(endDate).getTime() >= new Date(Date.parse(r.reviewDate.replace('年', '-').replace('月', '-').replace('日', ''))).getTime())) {
				b = false;
				return b;
			}
		}
		if (reviewsDatatype != null && reviewsDatatype != "" && reviewsDatatype != "全部" && reviewsDatatype != "-评论类型-") {
			if (reviewsDatatype != r.asinType) {
				b = false;
				return b;
			}
		}
		if (fieldKeywords != null && fieldKeywords != "") {
			var as = "/" + fieldKeywords + "/g";
			var reviewBody = r.reviewBody.replace(eval(as), '<span style="color:#E976BA">' + fieldKeywords + '</span>');
			if (r.reviewBody == reviewBody) {
				b = false;
				return b;
			}
			r.reviewBody = reviewBody;
		}
		return b;
	})

	if (reviewsDataDate == "评论时间升序") {
		var dsData = [];
		YZ_REVIEWDATA_FILTER.forEach(function (i, t) {
			t = YZ_REVIEWDATA_FILTER.length - t - 1;
			var data = YZ_REVIEWDATA_FILTER[t];
			dsData.push(data)
		})
		YZ_REVIEWDATA_FILTER = dsData;
	}
	YZ_PAGECOUNT = Math.ceil(YZ_REVIEWDATA_FILTER.length / 20)
	$(".YZ-pagination-container").createPage({
		pageCount: YZ_PAGECOUNT,
		current: RENDER_P,
		backFn: function (p) {
			RENDER_P = p
			render();//重新渲染
		},
	});
	render();
}



(function ($) {

	var ms = {
		init: function (obj, args) {
			return (function () {
				ms.fillHtml(obj, args);
				ms.bindEvent(obj, args);
			})();
		},
		//填充html
		fillHtml: function (obj, args) {
			return (function () {
				obj.empty();
				obj.append('<div class="YZ-pagination"></div>')
				var objc = obj.children('.YZ-pagination')
				// //上一页
				if (args.current > 1) {
					obj.prepend('<span class="YZ-page-change YZ-prev prevPage"><i class="arrow2"></i>上一页</span>');

				} else {
					obj.remove('.prevPage');
					obj.prepend('<span class="YZ-page-change YZ-prev disabled"><i class="arrow2"></i>上一页</span>');

				}
				//中间页码
				if (args.current != 1 && args.current >= 4 && args.pageCount != 4) {
					objc.append('<a href="javascript:;" class="tcdNumber">' + 1 + '</a>');
				}
				if (args.current - 2 > 2 && args.current <= args.pageCount && args.pageCount > 5) {
					objc.append('<span>...</span>');
				}
				var start = args.current - 2, end = args.current + 2;
				if ((start > 1 && args.current < 4) || args.current == 1) {
					end++;
				}
				if (args.current > args.pageCount - 4 && args.current >= args.pageCount) {
					start--;
				}
				for (; start <= end; start++) {
					if (start <= args.pageCount && start >= 1) {
						if (start != args.current) {
							objc.append('<a href="javascript:;" class="tcdNumber">' + start + '</a>');
						} else {
							objc.append('<a href="javascript:;" class="active">' + start + '</a>');
						}
					}
				}
				if (args.current + 2 < args.pageCount - 1 && args.current >= 1 && args.pageCount > 5) {
					objc.append('<span>...</span>');
				}
				if (args.current != args.pageCount && args.current < args.pageCount - 2 && args.pageCount != 4) {
					objc.append('<a href="javascript:;" class="tcdNumber">' + args.pageCount + '</a>');
				}
				// //下一页
				if (args.current < args.pageCount) {
					obj.append('<span class="YZ-page-change YZ-prev nextPage">下一页<i class="arrow3"></i></span>');
				} else {
					obj.remove('.nextPage');
					obj.append('<span class="YZ-page-change YZ-prev disabled">下一页<i class="arrow3"></i></span>');
				}
			})();
		},
		//绑定事件
		bindEvent: function (obj, args) {
			return (function () {
				// console.log('解除上一次');
				$(".YZ-pagination-container").off("click", "a.tcdNumber");
				$(".YZ-pagination-container").off("click", "span.prevPage");
				$(".YZ-pagination-container").off("click", "span.nextPage");
				obj.on("click", "a.tcdNumber", function () {
					RENDER_P = parseInt($(this).text());
					ms.fillHtml(obj, { "current": RENDER_P, "pageCount": YZ_PAGECOUNT });
					if (typeof (args.backFn) == "function") {
						args.backFn(RENDER_P);
					}
				});
				//上一页
				obj.on("click", "span.prevPage", function () {
					RENDER_P = parseInt(obj.children('.YZ-pagination').children("a.active").text()) - 1;
					ms.fillHtml(obj, { "current": RENDER_P, "pageCount": YZ_PAGECOUNT });
					if (typeof (args.backFn) == "function") {
						args.backFn(RENDER_P);
					}
				});
				//下一页
				obj.on("click", "span.nextPage", function () {
					RENDER_P = parseInt(obj.children('.YZ-pagination').children("a.active").text()) + 1;
					ms.fillHtml(obj, { "current": RENDER_P, "pageCount": YZ_PAGECOUNT });
					if (typeof (args.backFn) == "function") {
						args.backFn(RENDER_P);
					}
				});
			})();
		}
		//解绑事件

	}
	$.fn.createPage = function (options) {
		var args = $.extend({
			pageCount: 15,
			current: 1,
			backFn: function () { }
		}, options);
		ms.init(this, args);
	}
})(jQuery);



//评论分析渲染初始化页面
function render () {

	$('#YZ-proAnaComm').html('');
	YZ_REVIEWDATA_RENDER = YZ_REVIEWDATA_FILTER.slice((RENDER_P - 1) * 20, RENDER_P * 20);//每页显示的数据
	YZ_REVIEWDATA_RENDER.forEach((i, index) => {
		// 星星数量
		var reviewStarNum = "";
		for (var j = 0; j < i.reviewStar.substr(0, 1); j++) {
			reviewStarNum += '<img src="chrome-extension://' + CHROME_ID + '/image/star-on-big.png">'
		}
		for (var j = 5; j > i.reviewStar.substr(0, 1); j--) {
			reviewStarNum += '<img src="chrome-extension://' + CHROME_ID + '/image/star-off-big.png">'
		}
		document.querySelector('#YZ-proAnaComm').innerHTML += `
		<div class=YZ-proComm> 
	 		<div><span>` + i.reviewTitle + `</span></div>
	 		<div> `+ reviewStarNum + `<span style="font-weight:500;vertical-align: middle;">  ` + i.profileName + `</span></div>
	 		<div><span>` + i.reviewDate + " " + i.reviewIP + `</span></div>
	 		<div>` + i.reviewBody + `</div>
	 	</div>
		`

	})
}




//日期去0
function dislodgeZero (date) {
	let strArray = date.split('-');
	strArray = strArray.map(function (val) {
		if (val[0] == '0') {
			return val = val.slice(1);
		} else {
			return val;
		}
	})
	return strArray.join('-');
}

//时间升序降序
//prop：对象数组排序的键，
//align：排序方式，"positive"正序，"inverted"倒序。
function compare (prop, align) {
	return function (a, b) {
		var value1 = a[prop];
		var value2 = b[prop];
		if (align == "positive") {//正序
			return new Date(value1) - new Date(value2);
		} else if (align == "inverted") {//倒序
			return new Date(value2) - new Date(value1);
		}
	}
}

//变体的详情数据
function asinDetail (review) {
	url = "https://www.amazon.com/dp/" + review.asin
	$.ajax({
		type: "GET",
		url: url,
		success: function (html) {
			var reviewDoc = $(html);

			//变体图片
			var proimg = $(reviewDoc).find("#imgTagWrapperId img")[0].src;
			review["img"] = '/';
			if (proimg.length > 0) {
				review["img"] = proimg
			}

			//获取变体价格
			var price = reviewDoc.find("#apex_desktop");
			var proPrice = price.find("[aria-hidden='true']");
			review["proPrice"] = "/";
			if (proPrice.length > 0) {
				review["proPrice"] = proPrice[0].innerText;
				if(proPrice[0].innerText.indexOf("%")!=-1){
					review["proPrice"] = proPrice[1].innerText;
				}
			}
			//卖家数
			var proSellerSum = reviewDoc.find("[class='olp-text-box']");
			review["proSellerSum"] = "1";
			if (proSellerSum[0]) {
				var sellerSumUrl = proSellerSum[0].innerText;
				var se = sellerSumUrl.split(')')[0];
				review["proSellerSum"] = se.split('(')[1].trim();
			}

			if (reviewDoc.find('#prodDetails').length > 0) {
				var reviewTable = reviewDoc.find('#prodDetails');
				var reviewTr = reviewTable.find('tr');
				review["proWeight"] = "0 g";
				review["proSize"] = '0 x 0 x 0 cm';
				review["shelfTime"] = '暂无数据';
				reviewTr.each(function (i, t) {
					var th = $(t).find('th');
					var td = $(t).find('td');
					if (th[0].innerText.trim() == "商品重量") {
						review["proWeight"] = td[0].innerText.trim();
					} else if (th[0].innerText.trim() == '包装尺寸' || th[0].innerText.trim() == '商品尺寸') {
						review["proSize"] = td[0].innerText.trim();
					} else if (th[0].innerText.trim() == 'Amazon.cn上架时间') {
						var shelfTime = td[0].innerText.trim();
						review["shelfTime"] = shelfTime.trim();
					} else if (th[0].innerText.trim() == "亚马逊热销商品排名") {
						var span = td.find('span span');
						var proBSR = span[0].innerText.split('第')[1].split('名')[0].trim();
						review["proBSR"] = proBSR;
					}
				})
			} else if (reviewDoc.find('#detailBulletsWrapper_feature_div').length > 0) {
				var reviewDiv = reviewDoc.find('#detailBulletsWrapper_feature_div')
				var reviewLi = reviewDiv.find('li');
				review["proWeight"] = "0 g";
				review["proSize"] = '0 x 0 x 0 cm';
				review["shelfTime"] = '暂无数据';
				reviewLi.each(function (i, t) {
					var th = $(t).find('.a-text-bold');
					var td = $(t).find('span')[1];
					if (th.context.outerText.trim().includes('包装尺寸') || th.context.outerText.trim().includes('商品尺寸')) {
						review["proWeight"] = th.context.outerText.trim().split(":")[1].trim().split(";")[1].trim();
						review["proSize"] = th.context.outerText.trim().split(":")[1].trim().split(";")[0].trim();
					} else if (th.context.innerText.trim().includes('Amazon.cn上架时间')) {
						review["shelfTime"] = th.context.outerText.trim().split(":")[1].trim()
					} else if (th.context.innerText.trim().includes("亚马逊热销商品排名")) {
						var span = th.find('.a-list-item ul li');
						var proBSR = span.context.outerText.trim().split('第')[1].split('名')[0].trim();
						review["proBSR"] = proBSR;
					}
				})

			}
		}
	})
}
//向页面加入变体数据
function insertDataAsin (data, asin, reviewsSum, reviewsAge,reviewParticiple) {
	var sum = 0;
	data.forEach(function (i, r) {
		sum += i.num;
	})
	$('#YZ-imgLoad').remove();
	$('.YZ-imgLoad').remove();
	insertThisAsin = `<ul class="list-inline mb-0">
							<li class="list-inline-item">
								<img src="`+ proimgThis + `" class="product-img-2" alt="product img">
							</li>
							<li class="list-inline-item">
								ASIN: `+ asin + `<br>
								<br/>
								商品名称：`+ proNameThis + `
							</li>

						</ul>
							共`+ sum + ` 评论 平均星级` + proreviewAgeThis + `分，其中5星评分数有` + reviewsSum + `个，占比` + reviewsAge + ``;

	$('#YZ-headerData').html(insertThisAsin);

	reviewParticipleHTML= '';
	reviewParticiple.msg.forEach(function(i,r){
		
		reviewParticipleHTML = reviewParticipleHTML+`<div style="margin: 0 17px 2px 0;">`+i.keyword +"("+i.count+")"+` </div>`;
	})
	$('#reviewParticiple').html(reviewParticipleHTML)

	insertDataAsinHTML = '';
	selectTypeDataHTML = '';
	data.forEach(function (i, r) {
		insertDataAsinHTML = insertDataAsinHTML +
			`<tr class="ttd">
				<td colspan="1" rowspan="1"  class="body_a_column_1" style="text-align:center;">`+ (r + 1) + `</td>
				<td colspan="1" rowspan="1" class="body_a_column_2 ttd_img"><img src="`+ i.img + `"/></td>
				<td colspan="1" rowspan="1" class="body_a_column_3 overflow_hidden_tw" style="width:120px">`+ i.asin + `</td>
				<td colspan="1" rowspan="1" class="body_a_column_4">`+ i.proBSR + `</td>
				<td colspan="1" rowspan="1" class="body_a_column_5">`+ i.proPrice + `</td>
				<td colspan="1" rowspan="1" class="body_a_column_6 overflow_hidden_tw" style="width:300px">`+ i.asinType + `</td>
				<td colspan="1" rowspan="1" class="body_a_column_7">`+ i.num + `</td>
				<td colspan="1" rowspan="1" class="body_a_column_8">`+ (i.reviewStarSum / i.num).toFixed(1) + `</td>
				<td colspan="1" rowspan="1" class="body_a_column_10">`+ ((i.num / sum) * 100).toFixed(0) + "%" + `</td>
				<td colspan="1" rowspan="1" class="body_a_column_11">`+ i.proSellerSum + `</td>
				<td colspan="1" rowspan="1" class="body_a_column_12">`+ i.shelfTime + `</td>
			</tr>`;
		if (i.asinType != '/') {
			selectTypeDataHTML += `<a class="listA">` + i.asinType + `</a>`;
		}

		$('#YZ-asinVariationsData').html(insertDataAsinHTML)
	})
	$('#selectReviewsTypeData').append(selectTypeDataHTML);


	reviewsDataTypeJs();

}

/*
 * 格式化字符串方式
 */
String.prototype.format = function (args) {
	var result = this;
	if (arguments.length > 0) {
		if (arguments.length == 1 && typeof (args) == "object") {
			for (var key in args) {
				if (args[key] != undefined) {
					var reg = new RegExp("({" + key + "})", "g");
					result = result.replace(reg, args[key]);
				}
			}
		}
		else {
			for (var i = 0; i < arguments.length; i++) {
				if (arguments[i] != undefined) {
					var reg = new RegExp("({)" + i + "(})", "g");
					result = result.replace(reg, arguments[i]);
				}
			}
		}
	}
	return result;
}

function sendDownloadMsg (url, reviewNode) {
	var subMsg = url.substr(url.indexOf('product-reviews') + 'product-reviews'.length + 1);
	var asin = subMsg.substr(0, subMsg.indexOf('/'));
	var host = location.origin;
	uuid = getGuid();
	initResult();
	total = 1;
	downloadComments(asin, host, url, 1)
}

function progressBar (event) {
	var loaded = event.loaded;
	var total = event.total;
	var percentComplete = Math.floor(100 * loaded / total); //已经上传百分比
}
function downloadComments (asin, website, linkReviewsUrl, i) {
	//表示取消了
	if (total == 0) {
		return;
	}
	var url = website + linkReviewsUrl;
	$.ajax({
		type: "GET",
		url: url,
		success: function (html) {
			++PAGE;
			document.getElementById('submit.review-now1').textContent = PAGE * 100 / MAX_PAGE + "%";
			if (PAGE == MAX_PAGE) {
				setTimeout(function () {
					document.getElementById('submit.review-now1').textContent = "评论下载";
				}, 500)
			}
			//$html = $.parseHTML(html);
			var reviewDoc = $(html)
			//首次初始化产品数据
			if (i == 1) {
				var productLink = reviewDoc.find("[data-hook='product-link']");
				if (productLink.length > 0) {
					p["productUrl"] = $(productLink[0]).attr("href");
					p["asin"] = asin;
					p["productName"] = (productLink[0]).outerText;
					var productLink = reviewDoc.find("[data-hook='cr-filter-info-review-rating-count']");
					p["reviewNum"] = productLink[0].outerText;
					p["reviews"] = [];
				}
			}
			//获取评论列表
			var reviewDiv = reviewDoc.find("[data-hook='review']")
			reviewDiv.each(function (i, r) {
				var obj = {};
				//评论人
				obj["profileName"] = $(r).find(".a-profile-name")[0].innerText;
				//获取评分
				obj["reviewStar"] = $(r).find(".a-icon-alt")[0].innerText;
				//评论标题
				obj["reviewTitle"] = $(r).find("[data-hook='review-title']")[0].innerText;
				//获取评论地址和日期，后面在拆分
				var rDate = $(r).find("[data-hook='review-date']");
				obj["reviewDate"] = rDate[0].innerText.split(' ')[0];
				obj["reviewIP"] = rDate[0].innerText.split(' ')[1];
				//获取评论颜色
				var rColor = $(r).find("[data-hook='format-strip']");
				obj["productUrlThis"] = "";
				obj["asinThis"] = "";
				if (rColor.length > 0) {
					obj["productUrlThis"] = rColor.attr('href');
					obj["asinThis"] = obj.productUrlThis.split('/')[4];
					obj["reviewColor"] = rColor[0].innerText;
				} else {
					obj["reviewColor"] = "";
				}
				//获取评论内容
				var rBody = $(r).find("[data-hook='review-body']");
				obj["reviewBody"] = rBody[0].innerText;
				var rHelpful = $(r).find("[data-hook='helpful-vote-statement']");
				if (rHelpful.length > 0)
					obj["helpfulText"] = rHelpful[0].innerText.trim();
				else
					obj["helpfulText"] = "";

				var VP = $(r).find("[data-hook='linkless-format-strip-whats-this']");
				obj["reviewVp"] = "";
				if (VP.length > 0) {
					obj["reviewVp"] = "Y";
				}

				//评论图片
				var img = $(r).find("[data-action='a-modal']");
				obj["imgSum"] = 0;
				if (img.length > 0) {
					obj["imgSum"] = img.length;
				}
				//评论视频
				var video = $(r).find("[class='vjs-poster']");
				obj["videoSum"] = 0;
				if (video.length > 0) {
					obj["videoSum"] = video.length;
				}
				let data = Object.assign(obj,p);
				result.push(data);
			})
			var has = reviewDoc.find("[data-hook='pagination-bar']")
			//
			if (has.length > 0&& i< MAX_PAGE) {
				var hasNext = $(has[0]).find(".a-last");
				if (hasNext.length > 0) {
					var nextUrl = $(hasNext[0]).find('a').attr("href");
					if (nextUrl) {
						downloadComments(asin, website, nextUrl, i + 1)
					} else {
						requestNotify(url, asin, true, "");
					}
				}
			} else {
				requestNotify(url, asin, true, "");
			}
		}
		,
		error: function (xhr, status, error) {
			requestNotify(url, asin, false, error);
		}
	});
}


// Generate four random hex digits. 
function S4 () {
	return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
};
// Generate a pseudo-GUID by concatenating random hexadecimal. 
function guid () {
	return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
};
//get uuid
function getGuid () {
	//生成新的ID
	uuid = guid();
	return uuid;
}

/*
* 初始化计数
*/
function initResult () {
	total = 0;
	process = 0;
	p = [];
	result = [];
}

/*
* 添加评论到集合
*/
function addReviewObj (asin, reviewObj) {
	var product = result.filter(function (r) { return r.asin == asin });
	if (product.length > 0) {
		var reviews = product[0]["reviews"];
		reviews.push(reviewObj);
	}
}
// true 成功  false 失败
function requestNotify (url, asin, flag, error) {
	process = process + 1;
	//获取成功，则保存
	if (total === process) {
		setTimeout(function () {
			var text = document.getElementById("twotabsearchtextbox")
			chrome.runtime.sendMessage({ type: "finishSendData", reviews: result, uuidName: text.value }, function (response) {
				const a = document.createElement('a');
				a.style.display = 'none'
				a.href =YZ_HTTP+ "chrome/download?fileName="+response.data.data;
				a.target = '_blank';
				a.click();
			});
		}, 1000);
	}
}


chrome.runtime.onMessage.addListener(
	function (request, sender, sendResponse) {
		if (request.greeting == "hello") {
			sendResponse({ farewell: "I'm contentscript,goodbye!" });
		}
		return true;
	});

var amazonurl = "https://www.amazon.com/";
// 注意，必须设置了run_at=document_start 此段代码才会生效
document.addEventListener('DOMContentLoaded', function () {

	if (location.host == 'www.amazon.com') {
		var easyui_icon_url = "https://www.jeasyui.net/Application/Home/View/Public/js/easyui/themes/icon.css";
		var easyui_color_url = "https://www.jeasyui.net/Application/Home/View/Public/js/easyui/themes/color.css";
		var easyui_url = "https://www.jeasyui.net/Application/Home/View/Public/js/easyui/themes/default/easyui.css";
		var easyui_js = "https://www.jeasyui.net/Application/Home/View/Public/js/easyui/jquery.easyui.min.js";
		var easyui_jquery = "https://www.jeasyui.net/Application/Home/View/Public/js/easyui/jquery.min.js";
		addCss(easyui_icon_url);
		addCss(easyui_color_url);
		addCss(easyui_url);
		addScript(easyui_jquery);
		addScript(easyui_js);
		var reviewDiv = document.createElement("div");
		reviewDiv.id = "showDiv";
		$('body').after(reviewDiv)

		// 登录弹窗zz
		showLogin();
		$('#signinDiv').css("background-image", "url(chrome-extension://" + CHROME_ID + "/image/tmjl-bg.png)");
		// 加载框

		$('#option li').click(function () {
			$(this).addClass('active').siblings().removeClass('active');
			var a = $(this).index();
			$('#card li:eq(' + a + ')').addClass('active').siblings().removeClass('active');
		})
		// $('.yz-register').click(function () {
		// 	$(".login_count_c").show();
		// 	$(".login_count_c_title").show();
		// 	$(".login_count_a").hide();
		// })
		$('#register_return').click(function () {
			$(".login_count_c").hide();
			$(".login_count_c_title").hide();
			$(".login_count_a").show();
		})
		$(".icon_e").click(function () {
			$(".login_count_a").hide();
		})
		$(".icon_z").click(function () {
			$(".login_count_a").show();
		})

		$("#btn").click(function () {

			var username = document.getElementById("username").value;
			if (username != '') {
				let userdata = {
					"userName": username,
					"uuid":username
				}
				chrome.runtime.sendMessage({ userdata: userdata, type: "getSmsCode" }, function (response) {
					if (response.msg == "0") {
						YZ_USER = response.data;
						YZ_SIZEPAGE = response.page;
						$('#divicon').click();
						$('#signinDiv').css("display", "none");
					} else {
						alert(response.msg)
					}
				})
			} else {
				alert('请输入账号')
			}

			// $("#btn").val("60s后重新获取").attr("disabled", "disabled");
			// var count = 59;
			// //jquery要用setInterval()定时器，因为这里不会调用倒计时函数，要循环执行
			// var interval = setInterval(() => {
			// 	if (count == 0) {
			// 		//因为button是<input>元素，所以这里要用.val()方法
			// 		$("#btn").val("重新获取").removeAttr("disabled");
			// 		count = 59;
			// 		//当倒计时结束，这里要清除定时器
			// 		clearTimeout(interval);
			// 	} else {
			// 		$("#btn").val(count + "s后重新获取").attr("disabled", "disabled");
			// 		count--;
			// 	}
			// }, 1000);
		})
		$("#btnSign").click(function () {
			$("#btnSign").val("60s后重新获取").attr("disabled", "disabled");
			var count = 59;
			//jquery要用setInterval()定时器，因为这里不会调用倒计时函数，要循环执行
			var interval = setInterval(() => {
				if (count == 0) {
					//因为button是<input>元素，所以这里要用.val()方法
					$("#btnSign").val("重新获取").removeAttr("disabled");
					count = 59;
					//当倒计时结束，这里要清除定时器
					clearTimeout(interval);
				} else {
					$("#btnSign").val(count + "s后重新获取").attr("disabled", "disabled");
					count--;
				}
			}, 1000);
		})

		chrome.runtime.onMessage.addListener(
			function (request, sender, sendResponse) {
				if (request.action == "beforeLogin") {
					$('#signinDiv').css("display", "block");
				}
				//popup打开插件
				if (request.action == "openPlugin") {
					$('#divicon').click();
					// $('#divicon').trigger('click');
				}
				// 退出登录后关闭插件
				if (request.action == "outLogin") {
					$('#hid').click();
				}
			}
		);



		$('#login-hid').click(function () {
			$('#signinDiv').css("display", "none");
		})
		$('#register').click(function () {
			// alert(document.getElementById("register_uuid").value)
			alert(document.getElementById("register_sms").value)
			var username = document.getElementById("register_username").value;
			var phone = document.getElementById("register_phone").value;
			var pwd = document.getElementById("register_password").value;
			var password = document.getElementById("register_pwd").value;
			// var code = document.getElementById("register_uuid").value;
			var code = document.getElementById("register_sms").value;
			var flag = document.getElementById("form-check-input")

			if (username.length >= 2 && username.length <= 20) {
				if (isPoneAvailable(phone)) {
					if (pwd.length >= 5 && pwd.length <= 20) {
						if (password.length >= 5 && password.length <= 20) {
							if (pwd == password) {
								if (code != '') {
									if (flag.checked) {
										var userdata = {
											"username": username,
											"password": password,
											"phonenumber": phone,
											"code": code,
											"uuid": uuid
										}
										chrome.runtime.sendMessage({ userdata: userdata, type: "register" }, function (response) {
											if (response.msg == "0") {
												alert("注册成功")
											} else {
												alert(response.msg)
											}
										});
									} else {
										alert("请阅读用户条款")
									}
								} else {
									alert('请输入验证码')
								}
							} else {
								alert("两次输入的密码不一致")
							}
						} else {
							alert("用户密码长度必须介于 5 和 20 之间")
						}
					} else {
						alert("用户密码长度必须介于 5 和 20 之间")
					}
				} else {
					alert("手机号输入不正确")
				}
			} else {
				alert("用户账号长度必须介于 2 和 20 之间")
			}

		})

		function isPoneAvailable (poneInput) {
			var myreg = /^[1][3,4,5,6,7,8,9][0-9]{9}$/;
			if (!myreg.test(poneInput)) {
				return false;
			} else {
				return true;
			}
		}
		// 登录界面
		$('#login').click(e => {
			var username = document.getElementById("username").value;
			var code = document.getElementById("smscode").value
			if (username != '') {
					if (code != '') {
						let userdata = {
							"userName": username,
							"smsCode": code,
							"uuid": username
						}
						chrome.runtime.sendMessage({ userdata: userdata, type: "smsLogin" }, function (response) {
							if (response.msg == "0") {
								YZ_USER = response.data;
								$('#divicon').click();
								$('#signinDiv').css("display", "none");
							} else {
								alert(response.msg)
							}
						});

					} else {
						alert('请输入验证码')
					}
			} else {
				alert('请输入账号')
			}
		})
		$('#login_pwd').click(e => {
			var username = document.getElementById("phone").value;
			var password = document.getElementById("pwd").value;
			if (username != '') {
				if (password != '') {
						var userdata = {
							"userName": username,
							"password": password,
							"uuid": uuid
						}
						chrome.runtime.sendMessage({ userdata: userdata, type: "login" }, function (response) {
							if (response.msg == "0") {
								YZ_USER = response.data;
								$('#divicon').click();
								$('#signinDiv').css("display", "none");
							} else {
								alert(response.msg)
							}
						});
				} else {
					alert('请输入密码1')
				}
			} else {
				alert('请输入账号')
			}
		})
		var uuid = '';
		$('.yz-codeimg').click(e => {
			getImg();
		})
		$(function () {
			getImg();
		})
		function getImg () {
			chrome.runtime.sendMessage({ type: "getloginImg" }, function (response) {
				$('.yz-codeimg').attr('src', 'data:image/gif;base64,' + response.loginImg);
				uuid = response.uuid;
			});
		}
		// 账号密码登录界面end

		var main = document.createElement("div");
		main.id = "divicon";
		$('body').after(main);
		var torf = false;
		var firstTime = 0;
		var lastTime = 0;
		$('#divicon').css("background-image", "url(chrome-extension://" + CHROME_ID + "/image/logo.png)");
		document.getElementById("divicon").addEventListener('mouseup', function (event) {
			lastTime = new Date().getTime();
			if ((lastTime - firstTime) > 200) {
				torf = true;
			}
		}, false);
		document.getElementById("divicon").addEventListener('mousedown', function (event) {
			firstTime = new Date().getTime();
			let x = event.pageX - main.offsetLeft
			let y = event.pageY - main.offsetTop
			document.addEventListener('mousemove', move)
			// 也可以吧document换成main都行
			function move (event) {
				// 盒子距离body的距离=鼠标距离body的距离-鼠标距离盒子的距离
				main.style.left = event.pageX - x + 'px'
				main.style.top = event.pageY - y + 'px'
			}
			// 鼠标抬起
			document.addEventListener('mouseup', function () {
				document.removeEventListener('mousemove', move)
			})
		}, false);

		document.getElementById("divicon").addEventListener('click', function () {
			if (torf) {
				torf = false;
			} else {
				if (THIS_PAGE != window.location.href) {
					chrome.runtime.sendMessage({ type: "code" }, function (response) {
						if (response.isLogin == "0") {
							$('#signinDiv').css("display", "block");
						} else {
							var linkReviewsUrl = window.location.href;
							requestReviewData(linkReviewsUrl, 1, result, 0);
							proListingShow();
						}
					});
				} else {
					$('#login-page').show();
				}
			}

		}, false);


	}
});



function showLogin () {
	var loginDiv = document.createElement("div");
	loginDiv.id = "signinDiv";
	loginDiv.className = "signinDiv";
	$('#showDiv').after(loginDiv)
	$('#signinDiv').css("display", "none");
	var lf = `<div class="s-move-content-header" style="position: absolute;right: 10px;top: 10px;"><button id=login-hid class="btn_1" style="background:#ff644f"></button></div>
		<div class="body_count">
		<h3 class="login_count_c_title" style="display:none;">注册页面</h3>
		<div class="login_count">
			<div class="login_count_a">
				<div id="all">
					<ul id="option">
						<li class="active login_left">账号登录</li>
						<li class="login_right">验证码登录</li>
					</ul>
					<ul id="card">
						<li class="active">
							<!--输入框-->
							<div class="login_bot_count">
								<img src="chrome-extension://`+ CHROME_ID + `/image/tubiao-07.png" alt="" />
								<input type="text" id="phone" placeholder="请输入账号" required="required" name="" />
							</div>
							<div class="login_bot_count">
								<img src="chrome-extension://`+ CHROME_ID + `/image/tubiao-06.png" alt="" />
								<input type="password" required="required" name="" id="pwd" placeholder="请输入密码"  />
							</div>
							<!--登录按钮-->
							<button id="login_pwd" class="login_button">登录</button>
							<a class="yz-register" href="https://www.vmapg.com/login?pageType=register" target="_blank">立即注册</a>
						</li>
						<li class="login_account">
							<!--输入框-->
							<div class="login_account_count">
								<img src="chrome-extension://`+ CHROME_ID + `/image/tubiao-07.png" alt="" />
								<input type="text" name="" class="mobile_input" placeholder="请输入手机号码或邮箱"id="username"  />
							</div>
							<div class="login_account_counts">
								<img src="chrome-extension://`+ CHROME_ID + `/image/tubiao-06.png" alt="" />
								<input type="" name="" id="smscode" placeholder="请输入验证码" />
								<input class="account_code" type="button" id="btn" value="获取验证码" />
							</div>
							<!--登录按钮-->
							<button id="login" class="login_account_button">登录</button>
							<a class="yz-register" href="https://www.vmapg.com/login?pageType=register" target="_blank">立即注册</a>
						</li>
					</ul>
				</div>
			</div>
		</div>
	</div>`
	$('#signinDiv').html(lf);
}

function addCss (url) {
	var css = document.createElement('link');
	css.setAttribute('rel', 'stylesheet');
	css.setAttribute('type', url);
	css.setAttribute('link', url);
	document.getElementsByTagName('head')[0].appendChild(css);
}
function addScript (url) {
	var script = document.createElement('script');
	script.setAttribute('type', 'text/javascript');
	script.setAttribute('src', url);
	document.getElementsByTagName('head')[0].appendChild(script);
}
function requestReviewData (linkReviewsUrl, i, result, requestReviewDataSum) {
	$.ajax({
		//async:false,
		type: "GET",
		url: linkReviewsUrl,
		success: function (html) {
			var boo = true;
			THIS_PAGE = window.location.href;
			var reviewDoc = $(html)
			//获取产品列表
			var proType = reviewDoc.find("[class='sg-col-4-of-24 sg-col-4-of-12 s-result-item s-asin sg-col-4-of-16 sg-col s-widget-spacing-small sg-col-4-of-20']")
			if (proType[5]) {
				proType = proType[5].innerText
			} else {
				proType = '无';
			}
			var reviewDiv = reviewDoc.find("[class='sg-col-4-of-24 sg-col-4-of-12 s-result-item s-asin sg-col-4-of-16 sg-col s-widget-spacing-small sg-col-4-of-20']")

			if (!reviewDiv[0]) {
				reviewDiv = reviewDoc.find("[class='sg-col-4-of-12 s-result-item s-asin sg-col-4-of-16 sg-col s-widget-spacing-small sg-col-4-of-20']")
			}
			if(reviewDiv.length == 0){
				showRequestReviewData(result);
				return null;
			}
			reviewDiv.each(function (i, r) {
				requestReviewDataSum = requestReviewDataSum + 1;
				var obj = {};
				//获取产品名称
				var proname = $(r).find("[class='a-size-medium a-color-base a-text-normal']");
				if (!proname[0]) {
					obj["proName"] = $(r).find("[class='a-size-base-plus a-color-base a-text-normal']")[0].innerText
				} else {
					obj["proName"] = proname[0].innerText.trim();
				}
				//获取asin
				obj["proAsin"] = $(r).attr("data-asin");

				obj["search"] = reviewDoc.find("[id='twotabsearchtextbox']")[0].value;

				//获取评论总数
				obj["totalComments"] = '暂无数据';
				var totalComments = $(r).find("[class='a-size-base s-underline-text']");
				if (totalComments[0]) {
					var tc = new Number(totalComments[0].innerText.trim().replace(/,/g, ""));
					obj["totalComments"] = tc;
				}

				//获取类目
				obj["proType"] = proType;

				//获取价格
				obj["proPrice"] = '暂无数据';
				var proPrice = $(r).find("[class='a-offscreen']");
				if (proPrice[0]) {
					obj["proPrice"] = proPrice[0].innerText.trim().replace(/US/, "");
				}

				//获取评分
				obj["proScore"] = '暂无数据';
				var proScore = $(r).find("[class='a-popover-trigger a-declarative']");
				if (proScore[0]) {
					obj["proScore"] = proScore[0].innerText.slice(0, 4).trim();
				}

				//获取产品主图
				obj["proImg"] = '暂无数据';
				var proImg = $(r).find("[class='s-image']");
				if (proImg[0]) {
					obj["proImg"] = proImg[0].src.trim()
				}

				//获取产品详情页URL
				obj["proUrl"] = '暂无数据';
				var prourl = $(r).find("[class='a-link-normal s-underline-text s-underline-link-text s-link-style a-text-normal']");

				if (prourl[0]) {
					obj["proUrl"] = prourl[0].href.trim();
					requestReview(obj, prourl[0].href, result);
				}
				result.push(obj);
				if (reviewDiv.length > 26) {
					if (requestReviewDataSum == YZ_SIZEPAGE * 2) {
						boo = false;
						return false;
					}
				} else {
					if (requestReviewDataSum == YZ_SIZEPAGE) {
						boo = false;
						return false;
					}
				}
			})
			var has = reviewDoc.find("[class='a-section a-spacing-none s-result-item s-flex-full-width s-widget s-widget-spacing-large']")
			if (has.length > 0) {
				var hasNext = $(has).find("a");
				if (hasNext.length > 0) {
					var nextUrl = $(hasNext[0]).attr("href");
					if (nextUrl) {
						if (boo) {
							requestReviewData(nextUrl, i + 1, result, requestReviewDataSum)
						} else {
							YZ_PRODATA = JSON.parse(JSON.stringify(result));
							showRequestReviewData(result);
							return linkReviewsUrl;
						}
					} else {
						reviewNode.textContent = "完成";
					}
				}
			}
		}
	});
	return linkReviewsUrl;
}

function showRequestReviewData (result) {
	setTimeout(function () {
		var p = Array.from(result)
		$('#YZ-imgLoad').remove();
		show(p);
	}, 10000);
}


// 密码显示与隐藏
$("#show_hide_password a").on('click', function (event) {
	event.preventDefault();
	if ($('#show_hide_password input').attr("type") == "text") {
		$('#show_hide_password input').attr('type', 'password');
		$('#show_hide_password i').addClass("bx-hide");
		$('#show_hide_password i').removeClass("bx-show");
	} else if ($('#show_hide_password input').attr("type") == "password") {
		$('#show_hide_password input').attr('type', 'text');
		$('#show_hide_password i').removeClass("bx-hide");
		$('#show_hide_password i').addClass("bx-show");
	}
});

function requestReview (obj, linkReviewsUrl, result) {
	$.ajax({
		//async:false,
		type: "GET",
		url: linkReviewsUrl,
		success: function (html) {
			var reviewDoc = $(html)
			//获取品牌店以及连接
			var brand = reviewDoc.find('#bylineInfo');
			obj["proBrand"] = '暂无数据';
			obj["proBrandurl"] = '暂无数据'
			if (brand[0]) {
				obj["proBrand"] = brand[0].innerText.trim().replace(/访问/, '');
				obj["proBrandurl"] = brand[0].href.trim();
			}

			//获取卖家及连接
			var seller = reviewDoc.find("#sellerProfileTriggerId");
			var sellerhttp = location.host;
			obj["proSeller"] = sellerhttp;
			obj["proSellerurl"] = sellerhttp;
			if (seller[0]) {
				obj["proSeller"] = seller[0].innerText.trim();
				obj["proSellerurl"] = seller[0].href.trim();
			}

			if (reviewDoc.find('#prodDetails').length > 0) {
				var reviewTable = reviewDoc.find('#prodDetails');
				var reviewTr = reviewTable.find('tr');
				obj["proWeight"] = "0 g";
				obj["proSize"] = '0 x 0 x 0 cm';
				obj["shelfTime"] = '暂无数据';
				reviewTr.each(function (i, t) {
					var th = $(t).find('th');
					var td = $(t).find('td');
					if (th[0].innerText.trim() == "商品重量") {
						obj["proWeight"] = td[0].innerText.trim();
					} else if (th[0].innerText.trim() == '包装尺寸' || th[0].innerText.trim() == '商品尺寸') {
						obj["proSize"] = td[0].innerText.trim();
					} else if (th[0].innerText.trim() == 'Amazon.cn上架时间') {
						var shelfTime = td[0].innerText.trim();
						obj["shelfTime"] = shelfTime.trim();
					} else if (th[0].innerText.trim() == "亚马逊热销商品排名") {
						var span = td.find('span span');
						var proBSR = span[0].innerText.split('第')[1].split('名')[0].trim();
						obj["proBSR"] = proBSR;
					}
				})
				proFBA(obj)
			} else if (reviewDoc.find('#detailBulletsWrapper_feature_div').length > 0) {
				var reviewDiv = reviewDoc.find('#detailBulletsWrapper_feature_div')
				var reviewLi = reviewDiv.find('li');
				obj["proWeight"] = "0 g";
				obj["proSize"] = '0 x 0 x 0 cm';
				obj["shelfTime"] = '暂无数据';
				reviewLi.each(function (i, t) {
					var th = $(t).find('.a-text-bold');
					if (th.context.outerText.trim().includes('包装尺寸') || th.context.outerText.trim().includes('商品尺寸')) {
						obj["proWeight"] = th.context.outerText.trim().split(":")[1].trim().split(";")[1].trim();
						obj["proSize"] = th.context.outerText.trim().split(":")[1].trim().split(";")[0].trim();
					} else if (th.context.innerText.trim().includes('Amazon.cn上架时间')) {
						obj["shelfTime"] = th.context.outerText.trim().split(":")[1].trim()
					} else if (th.context.innerText.trim().includes("亚马逊热销商品排名")) {
						var span = th.find('.a-list-item ul li');
						var proBSR = span.context.outerText.trim().split('第')[1].split('名')[0].trim();
						obj["proBSR"] = proBSR;
					}
				})
				proFBA(obj)
			}

			//毛利率
			obj["proGmin"] = '暂无数据';
			// if (obj["proPrice"] != '暂无数据') {
			// 	var proPrice = Number(obj["proPrice"].split('$')[1].replace(/,/g, ""))
			// 	var fba = Number(obj["proFBA"].split('$')[1])
			// 	var fbas = 0;
			// 	if (proPrice < 10) {
			// 		fbas = proPrice * 0.08;
			// 	} else {
			// 		fbas = proPrice * 0.18;
			// 	}
			// 	//Math.round((i.asctomm / i.totalComments)*10000)/100+'%'
			// 	obj["proGmin"] = (Math.round((((proPrice - fba - fbas) / proPrice) * 10000)) / 100).toFixed(2) + '%';
			// }


			//变体数
			// var twister = reviewDoc.find("#twister");
			// obj["twister"] = 1;
			// if(twister[0]){
			// 	var numDiv = twister.children('div');
			// 	numDiv.each(function(i,t){
			// 		var tli = $(t).find('li');
			// 		if(tli[0]){
			// 			tli.each(function(i,t){
			// 				var asinurl = $(t).attr('data-dp-url');
			// 				if(asinurl == null || asinurl == ''){
			// 					asinurl ='/dp/'+ $(t).attr('data-defaultasin')
			// 				}
			// 				twisterData(amazonurl+asinurl,1)

			// 			})
			// 		}else{
			// 			var topt = $(t).find('option')
			// 			if(topt[0]){
			// 				topt.each(function(i,t){

			// 				})
			// 			}
			// 		}
			// 		if(i<1){
			// 			return false;
			// 		}
			// 	})
			// 	//setTimeout(function() {obj["twister"] = TwisterNum;}, 3000);
			// 	obj["twister"] = TwisterSum;
			// 	TwisterSum = 0;
			// }


			//配送类型
			var fbaType = reviewDoc.find("#tabular-buybox");
			obj["proDistribution"] = '暂无数据'
			if (fbaType[0]) {
				var fbadiv = fbaType.find("[tabular-attribute-name='配送方']");
				var proDistribution = fbadiv[1].innerText.trim();
				if (proDistribution == 'Amazon.com') {
					obj["proDistribution"] = 'AMZ';
				} else if (proDistribution == 'Amazon') {
					obj["proDistribution"] = 'FBA';
				} else {
					obj["proDistribution"] = 'MFN';
				}
			}

			//QBA数量
			var askATFLink = reviewDoc.find('#askATFLink');
			obj["askATFLink"] = '暂无数据';
			if (askATFLink[0]) {
				obj["askATFLink"] = askATFLink[0].innerText.trim();
			}

			var proImgandvideos = reviewDoc.find("#altImages");
			obj["proImgandvideo"] = '暂无数据';

			if (proImgandvideos[0]) {
				var imgs = 0;
				var vids = 0;
				var a = proImgandvideos.find("li")
				a.each(function (i, t) {
					var e = $(t).attr('class')
					if (e == 'a-spacing-small item') {
						imgs = imgs + 1;
					}
					if (e == 'a-spacing-small item videoBlockIngress videoBlockDarkIngress') {
						var z = $(t).find('#videoCount')
						vids = z.context.innerText.trim().split(' ')[0];
					}
				})
				obj["proImgandvideo"] = imgs + '&' + vids;
			}

			//月评新增
			var asc = reviewDoc.find("[data-hook='see-all-reviews-link-foot']")
			obj["asctomm"] = 0;
			if (asc[0]) {
				var ascurl = asc[0].href.split('ref')[0] + "/ref=cm_cr_arp_d_viewopt_srt?ie=UTF8&reviewerType=all_reviews&sortBy=recent&pageNumber=1";
				ascData(obj, ascurl, 0)
				setTimeout(function () { obj["asctomm"] = sum; }, 1000);
			}

			//卖家数
			var proSellerSum = reviewDoc.find("[class='olp-text-box']");
			obj["proSellerSum"] = "1";
			if (proSellerSum[0]) {
				var sellerSumUrl = proSellerSum[0].innerText;
				var se = sellerSumUrl.split(')')[0];
				obj["proSellerSum"] = se.split('(')[1].trim();
			}
		}
	});
}

function proFBA (obj) {
	obj["proFBA"] = '暂无数据';
	if (obj["proWeight"] != "0 g" && obj["proSize"] != '0 x 0 x 0 cm') {
		var proWeight = 0;
		if (obj["proWeight"].split(' ')[1] == "g") {
			proWeight = obj["proWeight"].split(' ')[0].trim().toString().substring(1);
			proWeight = Number(proWeight) / 1000;
		} else if (obj["proWeight"].split(' ')[1] == "kilograms" || obj["proWeight"].split(' ')[1] == "kg") {
			proWeight = obj["proWeight"].split(' ')[0].trim().toString().substring(1);
			proWeight = Number(proWeight);
		} else if (obj["proWeight"].split(' ')[1] == "盎司") {
			proWeight = obj["proWeight"].split(' ')[0].trim().toString().substring(1);
			proWeight = (Number(proWeight) * 28.349 / 1000).toFixed(2);
		}

		var myDate = new Date;
		var mon = myDate.getMonth() + 1;//获取当前月
		var long_1 = Number(obj["proSize"].split(' ')[0].toString().slice(1));
		var long_2 = parseFloat(obj["proSize"].split(' x ')[1]);
		var long_3 = parseFloat(obj["proSize"].split(' x ')[2].split(' ')[0].trim());
		var t = 0.0;
		if (long_1 < long_2) {
			t = long_2;
			long_1 = t;
		}
		if (long_1 < long_3) {
			t = long_3;
			long_1 = t;
		}
		if (long_2 < long_3) {
			t = long_3;
			long_2 = t;
		}
		if (proWeight < 0.34 && long_1 < 15 && long_2 < 12 && long_3 < 0.75) {
			if (mon <= 9) {
				obj["proFBA"] = "$2.41";
			} else {
				obj["proFBA"] = "$2.39";
			}
		} else if (proWeight < 9.07 && long_1 < 18 && long_2 < 14 && long_3 < 8) {
			if (mon <= 9) {
				if (proWeight < 0.45) {
					obj["proFBA"] = "$2.99";
				} else if (proWeight > 0.45 && proWeight < 0.90) {
					obj["proFBA"] = "$4.18";
				} else {
					obj["proFBA"] = "$" + ((proWeight - 0.9) * 0.39 + 4.18).toFixed(2);
				}
			} else {
				if (proWeight < 0.45) {
					obj["proFBA"] = "$2.88";
				} else if (proWeight > 0.45 && proWeight < 0.90) {
					obj["proFBA"] = "$3.96";
				} else {
					obj["proFBA"] = "$" + ((proWeight - 0.9) * 0.35 + 3.96).toFixed(2);
				}
			}
		} else if (proWeight < 31.75 && long_1 < 60 && long_2 < 30 && (long_2 + long_3) * 2 < 130) {
			if (mon <= 9) {
				obj["proFBA"] = "$" + ((proWeight - 0.9) * 0.39 + 6.85).toFixed(2);
			} else {
				obj["proFBA"] = "$" + ((proWeight - 0.9) * 0.35 + 6.69).toFixed(2);
			}
		} else if (proWeight < 68.03 && long_1 < 108 && (long_2 + long_3) * 2 < 130) {
			if (mon <= 9) {
				obj["proFBA"] = "$" + ((proWeight - 0.9) * 0.39 + 9.20).toFixed(2);
			} else {
				obj["proFBA"] = "$" + ((proWeight - 0.9) * 0.35 + 8.73).toFixed(2);
			}
		} else if (proWeight < 68.03 && long_1 < 108 && (long_2 + long_3) * 2 < 165) {
			if (mon <= 9) {
				obj["proFBA"] = "$" + ((proWeight - 40.82) * 0.8 + 75.06).toFixed(2);
			} else {
				obj["proFBA"] = "$" + ((proWeight - 40.82) * 0.76 + 69.50).toFixed(2);
			}
		} else {
			if (mon <= 9) {
				obj["proFBA"] = "$" + ((proWeight - 40.82) * 0.92 + 138.08).toFixed(2);
			} else {
				obj["proFBA"] = "$" + ((proWeight - 40.82) * 0.88 + 131.44).toFixed(2);
			}
		}
	}
}
function twisterData (url, numli) {
	$.ajax({
		//async :false,
		type: "GET",
		url: url,
		success: function (html) {
			var data = $(html);
			var formData = data.find('#twister');
			if (formData[0]) {
				var tdiv = formData.children('div');
				tdiv.each(function (i, t) {
					if (i > 0) {
						numli = ($(t).find('li').length - $(t).find("[class='swatchUnavailable']").length) * numli;
					}
				})
				getTwister(numli)
			}
		}
	});
}

var TwisterSum = 0;
function getTwister (a) {
	TwisterSum = TwisterSum + a;
}


var sum = 0;
function ascData (obj, ascurl, i) {
	var ft = true;
	$.ajax({
		//async :false,
		type: "GET",
		url: ascurl,
		success: function (html) {
			var reviewDoc = $(html)
			var reviewDiv = reviewDoc.find("[data-hook='review']")
			reviewDiv.each(function (a, r) {
				//获取日期
				var rDate = $(r).find("[data-hook='review-date']");
				var data = rDate[0].innerText.split('月')[0].trim();
				var myDate = new Date;
				var year = myDate.getFullYear(); //获取当前年
				var mon = myDate.getMonth() + 1;//获取当前月
				var now = year + "年" + mon;
				if (data == now) {
					i = i + 1;
				} else {
					ft = false;
					return false;
				}
			})
			if (ft) {
				var has = reviewDoc.find("[data-hook='pagination-bar']")
				var hasNext = $(has[0]).find(".a-last");
				if (hasNext.length > 0) {
					var nextUrl = $(hasNext[0]).find('a').attr("href");
					if (nextUrl) {
						i = ascData(obj, nextUrl, i)
					}
				}
			}
			getascData(i);
		}
	});
	return i;
}

function getascData (i) {
	sum = i;
	return sum;
}

function proListingShow () {
	var t = `
	<div class="s-move-content-outer"  id="login-page">
	<!--头-->
	<div class="card-body" style="height: 50px;padding:0;" >
									 <div class="row align-items-center bgcredorange" style="color:#fff;padding: 0 1rem; height:50px;">
										 <div class="col-lg-5 col-xl-5" >
										 功能
										 </div>
										 <div class="col-lg-5 col-xl-5">
											 <span>按钮</span>
										 </div>
										<div class="col-lg-2 col-xl-2" style>
											<div class="s-move-content-header" style="float:right;">
												<button id=hid class="btn_1"></button>
												
												<button id="fullScreen" class="btn_2">
													<span class="iconfont magnify">&#xe6a7;</span>
													<span class="iconfont shrink" style="display:none;">&#xe7af;</span>
												</button>

												<button id="condition" class="btn_3" title="筛选条件设置">
													<span class="iconfont">&#xe678;</span>
												</button>
											</div>
										</div>
									 </div>
								 </div>
								 <!--头end-->
	<div class="wrapper">
	 <div class="row row-cols-1 row-cols-md-2 row-cols-xl-4">
       <div class="col"></div>
				   <div class="col">
					<div class="card radius-10 border-start border-0 border-3 border-danger"></div>
				  </div>
	   <div class="col"></div>
	   <div class="col"></div> 
	  </div>
				 <div class="card radius-10" style="height: 100%;">
					<div class="card-body" id="show-body" style="position:absolute;height:100%;  width: 100%; overflow:auto; transition: all 0.5s ease 0s; padding:0.5rem 0;">
					
					   <div class="d-flex align-items-center" id="show-bheader" style="height: 90px;padding: 0 1rem; position:relative;left:0;">
						   <div>
							   <h6 class="mb-0">  </h6>
							   <div class="row row-cols-1 row-cols-md-2 row-cols-xl-4">
                   <div class="col">
					 <div class="card radius-10 border-start border-0 border-3 border-danger">
						<div class="card-body">
							<div class="d-flex align-items-center">
								<div>
									<p class="mb-0 text-secondary">ASIN数量</p>
									<h4 class="my-1 text-success" style="padding-left: 10px;font-size: 26px; height: 43px; line-height: 38px;" id=YZ_asinSum >/</h4>
									<p class="mb-0 font-11">  </p>
								</div>
							</div>
						</div>
					 </div>
				   </div>
				   <div class="col">
					<div class="card radius-10 border-start border-0 border-3 border-danger">
					   <div class="card-body">
						   <div class="d-flex align-items-center">
							   <div>
								   <p class="mb-0 text-secondary">平均价格</p>
								   <h4 class="my-1 text-success" id=YZ_proPriceSum>/</h4>
								   <p class="mb-0 font-11">较上周增长...</p>
							   </div>

						   </div>
					   </div>
					</div>
				  </div>
				  <div class="col">
					<div class="card radius-10 border-start border-0 border-3 border-danger">
					   <div class="card-body">
						   <div class="d-flex align-items-center">
							   <div>
								   <p class="mb-0 text-secondary">平均销售排名</p>
								   <h4 class="my-1 text-success" id=YZ_proAgeBSR>/</h4>
								   <p class="mb-0  font-11" >较上周下降...</p>
							   </div>
						   </div>
					   </div>
					</div>
				  </div>
				  <div class="col">
					<div class="card radius-10 border-start border-0 border-3 border-danger">
					   <div class="card-body">
						   <div class="d-flex align-items-center">
							   <div>
								   <p class="mb-0 text-secondary">平均评分</p>
								   <h4 class="my-1 text-success" id=YZ_proScoreAge>/</h4>
								   <p class="mb-0 font-11">最高...|最低...</p>
							   </div>
						   </div>
					   </div>
					</div>
				  </div> 
				</div>
		</div>
				<div class="widgets-icons-2 rounded-circle bg-gradient-bloody text-white ms-auto">9</div> 
				<div style="padding:0 0.5rem">
				 	<p class="mb-0 text-secondary">商机分析</p>
					<h4 class="my-1 text-success">高需求</h4>
					<p class="mb-0 font-11">市场广利润高</p>		   
				</div>
				<div class="YZ_market">
				
			</div>
		</div>   
					   <!--导航栏-->
					<div class="card-body" id="show-bnav" style="height: 40px;padding:0; position:relative; left:0" >
									 <div class="row align-items-center" id="show-blead" style="color:#fff;padding: 0 1rem; margin:0;">
										 <div class="col-lg-5 col-xl-5" >
						所属类目：<span id=YZ_proType>/</span>
										 </div>
										 <div class="col-lg-5 col-xl-5">
											 <span>筛选栏</span>
										 </div>
										 <div class="col-lg-2 col-xl-2" style>
										 <div class="s-move-content-header" style="float:right;"></div>
										 </div>
									 </div>
								 </div>
						<!--导航栏end-->
					<div id="tabdiv" class="table-responsive tabdiv" >
						<div class="table_header_wrapper">
						<table class="table table_thead align-middle mb-0" id="table" style="table-layout:fixed;">
						<colgroup>
							<col name="yz_el_table_1_column_1" style="width:50px">
							<col name="yz_el_table_1_column_2" style="width:440px;">
							<col name="yz_el_table_1_column_3" style="width:70px;">
							<col name="yz_el_table_1_column_4" style="width:140px;">
							<col name="yz_el_table_1_column_5" style="width:170px;">
							<col name="yz_el_table_1_column_6" style="width:80px;">
							<col name="yz_el_table_1_column_7"  style="width:80px;">
							<col name="yz_el_table_1_column_8"  style="width:90px;">
							<col name="yz_el_table_1_column_9"  style="width:120px;">
							<col name="yz_el_table_1_column_10" style="width:95px;">
							<col name="yz_el_table_1_column_11" style="width:105px;">
							<col name="yz_el_table_1_column_12" style="width:100px;">
							<col name="yz_el_table_1_column_13" style="width:180px;">
							<col name="yz_el_table_1_column_14" style="width:80px;">
							<col name="yz_el_table_1_column_15" style="width:70px;">
							<col name="yz_el_table_1_column_16" style="width:90px;">
							<col name="yz_el_table_1_column_17" style="width:100px;">
							<col name="yz_el_table_1_column_18" style="width:80px;">
							<col name="yz_el_table_1_column_19" style="width:190px;">
							<col name="yz_el_table_1_column_20" style="width:140px;">
						</colgroup>
						 <thead>
							<tr class="table_thead_tr" style="width:2470px">
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_1">#</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_2">产品信息</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_3">主图</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_4">ASIN</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_5">品牌</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_6">BSR</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_7">价格</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_8 pxsort">销量</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_9">销售额</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_10">毛利率</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_11">FBA费用</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_12">配送方式</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_13">buybox卖家</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_14">卖家数</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_15">评分</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_16">评分数</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_17">月评新增</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_18">留评率</th>
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_19">提问回答数</th>				  
								<th colspan="1" rowspan="1" class="yz_el_table_1_column_20">上架时间</th>
							</tr>
						</thead>
						</table>
						</div>
						<div class="table_body_wrapper">
						<table class="table table_body align-middle mb-0" id="table" style="table-layout: fixed;">
						<colgroup>
							<col name="yz_el_table_1_column_1" style="width:50px">
							<col name="yz_el_table_1_column_2" style="width:440px;">
							<col name="yz_el_table_1_column_3" style="width:70px;">
							<col name="yz_el_table_1_column_4" style="width:140px;">
							<col name="yz_el_table_1_column_5" style="width:170px;">
							<col name="yz_el_table_1_column_6" style="width:80px;">
							<col name="yz_el_table_1_column_7"  style="width:80px;">
							<col name="yz_el_table_1_column_8"  style="width:90px;">
							<col name="yz_el_table_1_column_9"  style="width:120px;">
							<col name="yz_el_table_1_column_10" style="width:95px;">
							<col name="yz_el_table_1_column_11" style="width:105px;">
							<col name="yz_el_table_1_column_12" style="width:100px;">
							<col name="yz_el_table_1_column_13" style="width:180px;">
							<col name="yz_el_table_1_column_14" style="width:80px;">
							<col name="yz_el_table_1_column_15" style="width:70px;">
							<col name="yz_el_table_1_column_16" style="width:90px;">
							<col name="yz_el_table_1_column_17" style="width:100px;">
							<col name="yz_el_table_1_column_18" style="width:80px;">
							<col name="yz_el_table_1_column_19" style="width:190px;">
							<col name="yz_el_table_1_column_20" style="width:140px;">
						</colgroup>
						<tbody id=Info></tbody>
						<tbody id="yzinfo"  class="yzinfo"><img id=YZ-imgLoad src="chrome-extension://`+ CHROME_ID + `/image/jiazai.gif" style="width: 303px;height: 201px;position: relative;left: 50%;transform: translateX(-50%);"></tbody>
					</table>
						</div>
					  
						</div>
				</div>
			</div>
			<div class="mask_filter_product" style="z-index: -1;"></div>
			<!--筛选条件设置-->
			<div id="conditionDiv" class="conditionDiv">
				<div class="conditionDiv_header">
					<span class="conditionDiv_header_left">筛选条件设置</span>
					<button id="conditionDiv_hid" class="btn_1 conditionDiv_header_right"></button>
				</div>
				<div class="conditionDiv_body">
					<div class="pr20">

						<div class="conditionInputItem">
							<div class="cInputItemLeft">
								<div style="text-align:right;">近30天<br/>销量</div>
							</div>
							<div class="cInputs">
								<div>
									<input type="number" placeholder="最小值" class="cInputInner" autocomplete="off">
								</div>
								<span style="margin:0 8px">~</span>
								<div>
									<input type="number" placeholder="最大值" class="cInputInner"autocomplete="off">
								</div>
							</div>
						</div>

						<div class="conditionInputItem">
							<div class="cInputItemLeft">
								<div style="text-align:right;">近30天<br/>销售额</div>
							</div>
							<div class="cInputs">
								<div>
									<input type="number" placeholder="最小值" class="cInputInner border_no_right_raduis" autocomplete="off">
									<div class="cInputAppend">
										<div style="width: 20px; color: rgb(191, 194, 199);">$</div>
									</div>
								</div>
								<span style="margin:0 8px">~</span>
								<div style="width:120px">
									<input type="number" placeholder="最大值" class="cInputInner border_no_right_raduis" autocomplete="off">
									<div class="cInputAppend">
										<div style="width: 20px; color: rgb(191, 194, 199);">$</div>
									</div>
								</div>
							</div>
						</div>

						<div class="conditionInputItem">
							<div class="cInputItemLeft">
								<div style="text-align:right;">BSR</div>
							</div>
							<div class="cInputs">
								<div>
									<input type="number" placeholder="最小值" class="cInputInner" autocomplete="off">
								</div>
								<span style="margin:0 8px">~</span>
								<div>
									<input type="number" placeholder="最大值" class="cInputInner"autocomplete="off">
								</div>
							</div>
						</div>

						<div class="conditionInputItem">
							<div class="cInputItemLeft">
								<div style="text-align:right;">价格</div>
							</div>
							<div class="cInputs">
								<div>
									<input type="number" placeholder="最小值" class="cInputInner border_no_right_raduis" autocomplete="off">
									<div class="cInputAppend">
										<div style="width: 20px; color: rgb(191, 194, 199);">%</div>
									</div>
								</div>
								<span style="margin:0 8px">~</span>
								<div style="width:120px">
									<input type="number" placeholder="最大值" class="cInputInner border_no_right_raduis" autocomplete="off">
									<div class="cInputAppend">
										<div style="width: 20px; color: rgb(191, 194, 199);">%</div>
									</div>
								</div>
							</div>
						</div>

						<div class="conditionInputItem">
							<div class="cInputItemLeft">
								<div style="text-align:right;">评分</div>
							</div>
							<div class="cInputs">
								<div>
									<input type="number" placeholder="最小值" class="cInputInner" autocomplete="off">
								</div>
								<span style="margin:0 8px">~</span>
								<div>
									<input type="number" placeholder="最大值" class="cInputInner"autocomplete="off">
								</div>
							</div>
						</div>

						<div class="conditionInputItem">
							<div class="cInputItemLeft">
								<div style="text-align:right;">评分数</div>
							</div>
							<div class="cInputs">
								<div>
									<input type="number" placeholder="最小值" class="cInputInner" autocomplete="off">
								</div>
								<span style="margin:0 8px">~</span>
								<div>
									<input type="number" placeholder="最大值" class="cInputInner"autocomplete="off">
								</div>
							</div>
						</div>

						<div class="conditionInputItem">
							<div class="cInputItemLeft">
								<div style="text-align:right;">月评新增</div>
							</div>
							<div class="cInputs">
								<div>
									<input type="number" placeholder="最小值" class="cInputInner" autocomplete="off">
								</div>
								<span style="margin:0 8px">~</span>
								<div>
									<input type="number" placeholder="最大值" class="cInputInner"autocomplete="off">
								</div>
							</div>
						</div>

						<div class="conditionInputItem">
							<div class="cInputItemLeft">
								<div style="text-align:right;">留评率</div>
							</div>
							<div class="cInputs">
								<div>
									<input type="number" placeholder="最小值" class="cInputInner border_no_right_raduis" autocomplete="off">
									<div class="cInputAppend">
										<div style="width: 20px; color: rgb(191, 194, 199);">%</div>
									</div>
								</div>
								<span style="margin:0 8px">~</span>
								<div style="width:120px">
									<input type="number" placeholder="最大值" class="cInputInner border_no_right_raduis" autocomplete="off">
									<div class="cInputAppend">
										<div style="width: 20px; color: rgb(191, 194, 199);">%</div>
									</div>
								</div>
							</div>
						</div>

						<div class="conditionInputItem">
							<div class="cInputItemLeft">
								<div style="text-align:right;">Q&A数</div>
							</div>
							<div class="cInputs">
								<div>
									<input type="number" placeholder="最小值" class="cInputInner" autocomplete="off">
								</div>
								<span style="margin:0 8px">~</span>
								<div>
									<input type="number" placeholder="最大值" class="cInputInner"autocomplete="off">
								</div>
							</div>
						</div>

						<div class="conditionInputItem">
							<div class="cInputItemLeft">
								<div style="text-align:right;">FBA运费</div>
							</div>
							<div class="cInputs">
								<div>
									<input type="number" placeholder="最小值" class="cInputInner" autocomplete="off">
								</div>
								<span style="margin:0 8px">~</span>
								<div>
									<input type="number" placeholder="最大值" class="cInputInner"autocomplete="off">
								</div>
							</div>
						</div>

						<div class="conditionInputItem">
							<div class="cInputItemLeft">
								<div style="text-align:right;">毛利率</div>
							</div>
							<div class="cInputs">
								<div>
									<input type="number" placeholder="最小值" class="cInputInner border_no_right_raduis" autocomplete="off">
									<div class="cInputAppend">
										<div style="width: 20px; color: rgb(191, 194, 199);">%</div>
									</div>
								</div>
								<span style="margin:0 8px">~</span>
								<div style="width:120px">
									<input type="number" placeholder="最大值" class="cInputInner border_no_right_raduis" autocomplete="off">
									<div class="cInputAppend">
										<div style="width: 20px; color: rgb(191, 194, 199);">%</div>
									</div>
								</div>
							</div>
						</div>

						<div class="conditionInputItem">
							<div class="cInputItemLeft">
								<div style="text-align:right;">卖家数</div>
							</div>
							<div class="cInputs">
								<div>
									<input type="number" placeholder="最小值" class="cInputInner" autocomplete="off">
								</div>
								<span style="margin:0 8px">~</span>
								<div>
									<input type="number" placeholder="最大值" class="cInputInner"autocomplete="off">
								</div>
							</div>
						</div>


						<div class="conditionInputItem">
							<div class="cInputItemLeft">
								<div style="text-align:right;">上架时间</div>
							</div>
							<div class="cInputs">
								<div class="select cInputInner c_select" style="width: 265px;">
									<!--存放选择的值-->
									<span class="selectVal" onselectstart="return false"><span id="selectValAll">不限</span></span>
									<!--放置icon-->
									<i class="xl-icon" style="background-image: url(chrome-extension://`+ CHROME_ID + `/image/xl-icon.png);"></i>
									<!--选择项-->
									<div class="selectList" style="top:30px">
										<div class="listA-all">
												<a href="javascript:;" name="selectValAll" class="listA">不限</a>
												<a href="javascript:;" name="monthOne" class="listA">近30天</a>
												<a href="javascript:;" name="monthThree" class="listA">近3个月</a>
												<a href="javascript:;" name="monthSix" class="listA">近6个月</a>
												<a href="javascript:;" name="yearOne" class="listA">近1年</a>
												<a href="javascript:;" name="yearThree" class="listA">近3年</a>
										</div>
									</div>
								</div>
							</div>
						</div>
						
						<div class="conditionInputItem">
							<div class="cInputItemLeft">
								<div style="text-align:right;">可售状态</div>
							</div>
							<div class="cInputs">
								<div class="select cInputInner c_select" style="width: 265px;">
									<!--存放选择的值-->
									<span class="selectVal" onselectstart="return false"><span id="selectValAll">不限</span></span>
									<!--放置icon-->
									<i class="xl-icon" style="background-image: url(chrome-extension://`+ CHROME_ID + `/image/xl-icon.png);"></i>
									<!--选择项-->
									<div class="selectList" style="top:30px">
										<div class="listA-all">
												<a href="javascript:;" name="selectValAll" class="listA">不限</a>
												<a href="javascript:;" name="sell" class="listA">可售</a>
												<a href="javascript:;" name="sellNot" class="listA">不可售</a>
										</div>
									</div>
								</div>
							</div>
						</div>


						<div class="conditionInputItem">
							<div class="cInputItemLeft">
								<div style="text-align:right;">卖家<br/>所属地</div>
							</div>
							<div class="cInputs">

								<div class="overallSelectB" style="position:relative;">
									<div class="selectB cInputInner c_select" style="width: 265px;">
										<!--存放选择的值-->
										<span class="selectVal" onselectstart="return false"><span id="selectValAll">不限</span></span>
										<!--放置icon-->
										<i class="xl-icon" style="background-image: url(chrome-extension://`+ CHROME_ID + `/image/xl-icon.png);"></i>
										<!--选择项-->
										
									</div>
									<div class="selectList" style="top:30px">
										<div class="listB-all">
												<a href="javascript:;"class="listUnB" name="selectValAll">不限</a>
												<a href="javascript:;"class="listB" name="china">中国</a>
												<a href="javascript:;"class="listB" name="america">美国</a>
												<a href="javascript:;"class="listB" name="otherCountries">其他</a>
										</div>
									</div>
								</div>
								
							</div>
						</div>



						<div 
						style="margin-top:50px;
						display: flex;
						justify-content: center;
						align-items: center;
						border-top: 1px solid rgb(239, 241, 244);
						padding: 35px 0px 40px;
						">	
							<button class="el_btn subBtn" id=YZ_proSelect>
								<span>立即查询</span>
							</button>
							<button id="conditionDiv_body_reset" class="el_btn resetBtn">
								<span>重置条件</span>
							</button>
						</div>
					</div>
				</div>
			</div>
</div>

<div class="footer-btn">
<div class="btndiv width85 showdiv-refresh">
	<button class="btn">
	<span class="iconfont icon-refresh" style="display:none">&#xec08;</span>
	<span class="iconfont icon-refreshing">&#xe699;</span>
	
	刷新</button>
</div>
<div class="btndiv width115">
	<button class="btn commodity_now" id=exePagePro>
	<span class="iconfont">&#xe610;</span>
	导出商品</button>

</div>
	`;
	$('#showDiv').html(t);

	var loginPage = document.querySelector('#login-page')
	fullScreen(loginPage)

	$('#login_out').click(function () {
		chrome.runtime.sendMessage({
			type: "logOut"
		}, res => {
			// 答复

		})

	})

	// 下拉列表
	//外层select框
	var oDropDown = $('.select');
	//选择列表项
	var oChangeA = $('.listA');
	oDropDown.click(function () {
		$(this).find('.selectList').slideToggle(100, "linear").siblings('.xl-icon').toggleClass('sq-icon');
	});
	oDropDown.mouseleave(function () {
		$(this).find('.selectList').slideUp(100, "linear").siblings('.xl-icon').removeClass('sq-icon');
	});
	oChangeA.click(function () {
		var that = $(this);
		oVal = $(this).text();
		$(this).addClass('click_list').siblings('.listA').removeClass('click_list');
		$(this).parents('.listA-all').parents('.selectList').siblings('.selectVal').html('<span id="' + that.attr('name') + '">' + oVal + '</span>').siblings('.xl-icon').toggleClass('sq-icon');
	});
	// 多选下拉列表
	var oDropDownB = $('.selectB');
	var oChangeB = $('.listB');
	var oChangeUnB = $('.listUnB');
	oDropDownB.siblings('.selectList').width(oDropDownB.outerWidth() + "px")
	function changeUnB (selectValDivB) {
		if (selectValDivB.find('.selectValB').length) {
			selectValDivB.children('#selectValAll').remove();
			// console.log("移除不限");
		} else {
			selectValDivB.append('<span class="selectValB-all" id="selectValAll">不限</span>');
			// console.log('添加不限');
		}
	}
	oDropDownB.click(function () {
		$(this).siblings('.selectList').slideToggle(100, "linear");
		$(this).children('.xl-icon').toggleClass('sq-icon');
	})
	$('.overallSelectB').mouseleave(function () {
		$(this).find('.selectList').slideUp(100, "linear");
		$(this).find('.xl-icon').removeClass('sq-icon');
	})
	oChangeB.click(function () {
		var that = $(this)
		var oVal = $(this).text();
		var selectValDivB = $(this).toggleClass('click_list').siblings('.listUnB').removeClass('click_list').parents('.listB-all').parents('.selectList').siblings('.selectB').children('.selectVal');
		if (that.hasClass('click_list')) {
			selectValDivB.append('<span class="selectValB" id="' + that.attr('name') + '">' + oVal + '&nbsp;</span>');
			// console.log($('#'+that.attr('name')+'').length+"有");
			changeUnB(selectValDivB)
		} else {
			selectValDivB.children('#' + that.attr('name') + '').remove();
			// console.log($('#'+that.attr('name')+'').length+"无");
			changeUnB(selectValDivB)
		}
	})
	oChangeUnB.click(function () {
		var selectValDivUnB = $(this).toggleClass('click_list').siblings('.listB').removeClass('click_list').parents('.listB-all').parents('.selectList').siblings('.selectB').children('.selectVal');
		// console.log(selectValDivUnB.find('.selectValB-all').length+"不限的长度");
		if (!selectValDivUnB.find('.selectValB-all').length) {
			selectValDivUnB.append('<span class="selectValB-all" id="selectValAll">不限</span>').find('.selectValB').remove();
			// console.log("都移除");
		}
	})
	//清空筛选中所有input的val
	$('#conditionDiv_body_reset').click(function () {
		$('.conditionDiv_body input').val('');
		$('.conditionDiv_body .selectB .selectVal ').html('<span id="selectValAll">不限</span>');
		$('.conditionDiv_body .select .selectVal ').html('<span id="selectValAll">不限</span>');
		$('.conditionDiv_body .selectList a').removeClass('click_list');
	})

	document.getElementById("hid").addEventListener('click', function () {
		$('#login-page').hide();

	});
	document.getElementById("condition").addEventListener('click', function () {
		$('#conditionDiv').animate({ right: '0' }, 'show');
		$('.mask_filter_product').css({ 'z-index': '1' })
	})
	document.getElementById("conditionDiv_hid").addEventListener('click', function () {
		$('#conditionDiv').animate({ right: '-400px' }, 'slow');
		$('.mask_filter_product').css({ 'z-index': '-1' });
	})

	//
	let flag = true;
	// document.getElementById("btn-self").addEventListener('click', function () {
	// 	if (flag) {
	// 		flag = false;
	// 		$('.dropdown').slideDown(100, 'linear');
	// 	} else if (!flag) {
	// 		flag = true;
	// 		$('.dropdown').slideUp(100, 'linear');
	// 	}
	// })

	//固定表头 
	let show_body = document.getElementById("show-body")
	let show_bnav = document.getElementById("show-bnav")
	let show_bheader = document.getElementById("show-bheader")
	let table = document.getElementById("table")
	let tabdiv = document.getElementById("tabdiv")
	let table_thead = document.querySelector(".table_thead")

	show_body.addEventListener('scroll', function () {
		let login_page_top = document.getElementById("login-page").offsetTop
		let slsh = show_body.scrollLeft;// 已拖动多少scrollleft
		if ((tabdiv.offsetTop - show_body.scrollTop) <= 0) {
			table_thead.style.cssText = 'table-layout: fixed;position:fixed;top:' + (login_page_top * 1 + 50 * 1) + 'px;left:' + (-slsh) + 'px;width:2470px;'
		} else {
			table_thead.style.cssText = 'table-layout: fixed;position:relative;width:2470px;'
		}
		let tablesw = table.scrollWidth;
		let maxsl = tablesw - show_body.clientWidth;
		if (slsh > maxsl) {
			show_bnav.style.left = maxsl + "px";
			show_bheader.style.left = maxsl + "px";
			// table_thead.style.left = -slsh + "px";
		} else {
			show_bnav.style.left = slsh + "px";
			show_bheader.style.left = slsh + "px";
		}

	});
	$('#YZ_proSelect').click(function () {
		var divDind = $("#conditionDiv").find("[class='conditionInputItem']");
		var resultData = result.filter(function (thisData) {
			var selectfind = true;
			divDind.each(function (divI, divt) {
				var input = $(divt).find("input");
				input.each(function (i, t) {
					if ($(t).val().length < 1) {
						return false;
					}
					switch (divI) {
						case 0:
							if (thisData.totalComments == null || thisData.totalComments == '' || thisData.totalComments == '/' || thisData.totalComments == '暂无数据') {
								selectfind = false;
								return false;
							}
							if (i > 0) {
								if (!(thisData.totalComments <= $(t).val())) {
									selectfind = false;
									return false;
								}
							} else {
								if (!(thisData.totalComments >= $(t).val())) {
									selectfind = false;
									return false;
								}
							}
							break;
						case 1:
							if (thisData.aprosum == null || thisData.aprosum == '' || thisData.aprosum == '/' || thisData.aprosum == '暂无数据') {
								selectfind = false;
								return false;
							}
							if (i > 0) {
								if (!(thisData.aprosum <= $(t).val())) {
									selectfind = false;
									return false;
								}
							} else {
								if (!(thisData.aprosum >= $(t).val())) {
									selectfind = false;
									return false;
								}
							}
							break;
						case 2:
							if (thisData.proBSR == null || thisData.proBSR == '' || thisData.proBSR == '/' || thisData.proBSR == '暂无数据') {
								selectfind = false;
								return false;
							}
							if (i > 0) {
								if (!(parseInt(thisData.proBSR.replace(/,/g, "")) <= $(t).val())) {
									selectfind = false;
									return false;
								}
							} else {
								if (!(parseInt(thisData.proBSR.replace(/,/g, "")) >= $(t).val())) {
									selectfind = false;
									return false;
								}
							}
							break;
						case 3:
							if (thisData.proPrice == null || thisData.proPrice == '' || thisData.proPrice == '/' || thisData.proPrice == '暂无数据') {
								selectfind = false;
								return false;
							}
							if (i > 0) {
								if (!(Number(thisData.proPrice.split('$')[1].replace(/,/g, "")) <= $(t).val())) {
									selectfind = false;
									return false;
								}
							} else {
								if (!(Number(thisData.proPrice.split('$')[1].replace(/,/g, "")) >= $(t).val())) {
									selectfind = false;
									return false;
								}
							}
							break;
						case 4:
							if (thisData.proScore == null || thisData.proScore == '' || thisData.proScore == '/' || thisData.proScore == '暂无数据') {
								selectfind = false;
								return false;
							}
							if (i > 0) {
								if (!(Number(thisData.proScore) <= $(t).val())) {
									selectfind = false;
									return false;
								}
							} else {
								if (!(Number(thisData.proScore) >= $(t).val())) {
									selectfind = false;
									return false;
								}
							}
							break;
						case 5:
							if (thisData.totalComments == null || thisData.totalComments == '' || thisData.totalComments == '/' || thisData.totalComments == '暂无数据') {
								selectfind = false;
								return false;
							}
							if (i > 0) {
								if (!(Number(thisData.totalComments) <= $(t).val())) {
									selectfind = false;
									return false;
								}
							} else {
								if (!(Number(thisData.totalComments) >= $(t).val())) {
									selectfind = false;
									return false;
								}
							}
							break;
						case 6:
							if (thisData.asctomm == null || thisData.asctomm == '' || thisData.asctomm == '/' || thisData.asctomm == '暂无数据') {
								selectfind = false;
								return false;
							}
							if (i > 0) {
								if (!(Number(thisData.asctomm) <= $(t).val())) {
									selectfind = false;
									return false;
								}
							} else {
								if (!(Number(thisData.asctomm) >= $(t).val())) {
									selectfind = false;
									return false;
								}
							}
							break;
						case 7:
							if (thisData.commentsPercentage == null || thisData.commentsPercentage == '' || thisData.commentsPercentage == '/' || thisData.commentsPercentage == '暂无数据') {
								selectfind = false;
								return false;
							}

							if (i > 0) {
								if (!(Number(thisData.commentsPercentage * 100) <= $(t).val())) {
									selectfind = false;
									return false;
								}
							} else {
								if (!(Number(thisData.commentsPercentage * 100) >= $(t).val())) {
									selectfind = false;
									return false;
								}
							}
							break;
						case 8:
							if (thisData.askATFLink == null || thisData.askATFLink == '' || thisData.askATFLink == '/' || thisData.askATFLink == '暂无数据') {
								selectfind = false;
								return false;
							}
							if (i > 0) {
								if (!(Number(thisData.askATFLink.split('个')[0]) <= $(t).val())) {
									selectfind = false;
									return false;
								}
							} else {
								if (!(Number(thisData.askATFLink.split('个')[0]) >= $(t).val())) {
									selectfind = false;
									return false;
								}
							}
							break;
						case 9:
							if (thisData.proFBA == null || thisData.proFBA == '' || thisData.proFBA == '/' || thisData.proFBA == '暂无数据') {
								selectfind = false;
								return false;
							}
							if (i > 0) {
								if (!(Number(thisData.proFBA.split('$')[1].replace(/,/g, "")) <= $(t).val())) {
									selectfind = false;
									return false;
								}
							} else {
								if (!(Number(thisData.proFBA.split('$')[1].replace(/,/g, "")) >= $(t).val())) {
									selectfind = false;
									return false;
								}
							}
							break;
						case 10:
							if (thisData.proGmin == null || thisData.proGmin == '' || thisData.proGmin == '/' || thisData.proGmin == '暂无数据') {
								selectfind = false;
								return false;
							}
							if (i > 0) {
								if (!(Number(thisData.proGmin.replace(/%/, "")) <= $(t).val())) {
									selectfind = false;
									return false;
								}
							} else {
								if (!(Number(thisData.proGmin.replace(/%/, "")) >= $(t).val())) {
									selectfind = false;
									return false;
								}
							}
							break;
						case 11:
							if (thisData.proSellerSum == null || thisData.proSellerSum == '' || thisData.proSellerSum == '/' || thisData.proSellerSum == '暂无数据') {
								selectfind = false;
								return false;
							}
							if (i > 0) {
								if (!(Number(thisData.proSellerSum) <= $(t).val())) {
									selectfind = false;
									return false;
								}
							} else {
								if (!(Number(thisData.proSellerSum) >= $(t).val())) {
									selectfind = false;
									return false;
								}
							}
							break;
					}
				})
			})
			return selectfind;
		})
		show(resultData)
	})
}

function show (result) {
	YZ_PRODATA_FILTER = result;
	var proPriceAge = 0;
	var proScoreAge = 0;
	var proBSR = 0;
	var td = '';
	if (result.length !=0) {
		result.forEach(function (i, t) {
			if (i.proPrice != '暂无数据') {
				var proPrice = Number(i.proPrice.split('$')[1].replace(/,/g, ""))
				proPriceAge = proPriceAge + proPrice;
			}
			if (i.proScore != '暂无数据') {
				var proScore = Number(i.proScore)
				proScoreAge = proScoreAge + proScore;
			}
			if (i.proBSR != '暂无数据' && i.proBSR != null) {
				var BSR = Number(i.proBSR.replace(/,/g, ""))
				proBSR = proBSR + BSR;
			}
			var aprosum = '暂无数据';
			if (i.totalComments != '暂无数据' && i.proPrice != '暂无数据') {
				aprosum = (i.totalComments * i.proPrice.split('$')[1].replace(",", "")).toFixed(2);
			}
			td = td +
				`<tr>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_1" style="width:50px;">` + (t + 1) + `</td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_2"><table><tr><td class="overflow_hidden_tw" style="width:420px;">`+ i.proName + `</td></tr><tr><td style="width:420px;"><p class="overflow_hidden_tw">产品重量: ` + i.proWeight + `产品尺寸: ` + i.proSize + `</p></td></tr></table></td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_3"><img src=`+ i.proImg + `  class="product-img-2" style="width:50px;height:50px;" alt="product img"></td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_4"><a href=`+ i.proUrl + ` class="overflow_hidden_tw" title="点击访问该商品" target="_blank" style="width:120px;vertical-align:middle;">` + i.proAsin + `</a></td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_5"><div > <a href=`+ i.proBrandurl + ` class="overflow_hidden_tw"  title="点击访问该品牌" target="_blank" style="width:150px;">` + i.proBrand + `</a></div></td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_6"><div > <a href="javascript:;" class="overflow_hidden_tw" title="点击数字查看历史趋势" target="_blank" style="width:60px;">`+ i.proBSR + `</a></div></td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_7"><div class="overflow_hidden_tw" style="width:60px;">`+ i.proPrice + `</div></td>' +
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_8"><div class="overflow_hidden_twa" style="width:70px;">`+ i.totalComments + `</div></td>' +
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_9"><div ><a href="javascript:;"  class="overflow_hidden_tw" title="日销量：29/天，点击查看详细&#10;其它蓝色数字也都可以点击看趋势" target="_blank" style="width:100px;">` + aprosum + `</a></div></td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_10"><div class="overflow_hidden_tw" style="width:75px;">` + i.proGmin + `</div></td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_11"><div class="overflow_hidden_tw" style="width:85px;">` + i.proFBA + `</div></td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_12"><div style="width:80px;"><a href="javascript:;" class="overflow_hidden_tw" title="配送方式" target="_blank">` + i.proDistribution + `</a></div></td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_13"><div ><a tyle="width:160px;" href=`+ i.proSellerurl + ` class="overflow_hidden_tw" title="美国卖家" target="_blank">` + i.proSeller + `</a></div></td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_14"><div ><a href="#" class="overflow_hidden_tw" title="点击数字查看跟卖列表" target="_blank" style="width:60px;">`+ i.proSellerSum + `</a> </div></td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_15"><div class="overflow_hidden_tw" style="width:50px;">`+ i.proScore + `</div></td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_16"><div class="overflow_hidden_tw" style="width:70px;">` + i.totalComments + `</div></td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_17"><div class="overflow_hidden_tw" style="width:80px;">` + i.asctomm + `</div></td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_18"><div style="width:60px;"><a href="javascript:;" class="overflow_hidden_tw" title="查看历史留评趋势&#10;留评率 = 当月新增评分数量/当月销量"  target="_blank">` + Math.round((i.asctomm / i.totalComments) * 10000) / 100 + '%' + `</a></div></td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_19"><div class="overflow_hidden_tw" style="width:170px;">`+ i.askATFLink + `</div></td>
					<td colspan="1" rowspan="1" class="yz_el_table_1_column_20"><div class="overflow_hidden_tw" style="width:120px;">` + i.shelfTime + `</div></td>
				</tr>`;
			$('#YZ_proType').html(result[0].proType);
		})
		proPriceAge = (proPriceAge / result.length).toFixed(2);
		proScoreAge = (proScoreAge / result.length).toFixed(2);
		proBSR = (proBSR / result.length).toFixed(0);
		$('#YZ_asinSum').html(result.length)
		$('#YZ_proPriceSum').html(proPriceAge)
		$('#YZ_proScoreAge').html(proScoreAge)
		$('#YZ_proAgeBSR').html(proBSR);
	}else{
		td= '<div font-size="30px" "> 请前往商品list页 </div>';
	}
	$('#yzinfo').html(td);
	complete();
}



function complete () {
	// //市场分析
	// document.getElementById("YZ_Analysis").addEventListener('click', function () {
	// 	$('.YZ_market_proceed').show().siblings().hide();
	// 	chrome.runtime.sendMessage({ type: "YZ_Analysis", reviews: YZ_PRODATA_FILTER }, function (response) {
	// 		$('.YZ_market_finish').show().siblings().hide();
	// 	});
	// })
	// //查看市场分析
	// document.querySelector('.YZ_market_finish').addEventListener('click', function () {
	// 	window.open('http://localhost/chrome/market', '_blank');
	// 	$('.YZ_market_now').show().siblings().hide();
	// })

	function showSelf (item) {
		item.show().siblings().hide();
	}
	// //导出评论
	// document.getElementById("exeProReview").addEventListener('click', function () {
	// 	// $('.review_proceed').show().siblings().hide();
	// 	showSelf($('.review_proceed'))
	// 	YZ_PRODATA.forEach(function (i, t) {
	// 		chrome.runtime.sendMessage({ asin: i.proAsin, type: "productReviews" }, function (response) {
	// 			// $('.review_finish').show().siblings().hide();
	// 			showSelf($('.review_finish'))
	// 		});
	// 	})
	// 	setTimeout(function () {
	// 		var text = document.getElementById("twotabsearchtextbox")
	// 		chrome.runtime.sendMessage({ type: "finishSendData", reviews: "", uuidName: text.value }, function (response) {

	// 		});
	// 	}, 7000);
	// });
	// // 前往官网查看导出评论
	// document.querySelector('.review_finish').addEventListener('click', function () {
	// 	window.open('http://localhost/chrome/yzamazonpro', '_blank')
	// 	// $('.review_now').show().siblings().hide();
	// 	showSelf($('.review_now'))
	// })

	// 导出商品
	document.getElementById("exePagePro").addEventListener('click', function () {
		var text = document.getElementById("twotabsearchtextbox")
		chrome.runtime.sendMessage({ result: result, type: "productsDataExe", uuidName: text.value }, function (response) {
				const a = document.createElement('a');
				a.style.display = 'none'
				a.href =YZ_HTTP+ "chrome/download?fileName="+response.data.data;
				console.log(a.href)
				a.target = '_blank';
				a.click();
		});
	});

	// // 前往官网查看导出商品
	// document.querySelector('.commodity_finish').addEventListener('click', function () {
	// 	window.open('http://localhost/chrome/yzamazonpro', '_blank')
	// 	showSelf($('.commodity_now'))
	// })
	// 切换刷新按钮状态
	$('.icon-refresh').show().siblings().hide();
	// 选品页面刷新
	document.querySelector('.showdiv-refresh').addEventListener('click', function () {
		initResult()
		var linkReviewsUrl = window.location.href;
		requestReviewData(linkReviewsUrl, 1, result, 0);
		proListingShow();
	})
}
