var URL="/-/en/product-reviews/{0}/ref=cm_cr_dp_d_show_all_btm?ie=UTF8&reviewerType=all_reviews&sortBy=recent";
//抓取结果
var result=[]
//限制商品最大页数评论
var MAX_PAGE=10;
var total=0;
var process=0;
//请求的标识
var uuid="";
//用户工号
var userNo="";

var usertoken = "";

var userName = "";

var password = "";

var YZ_USER=[];
//ASIN列表
var asinList=[];	

let YZ_HTTP = "https://www.vmapg.com/api/";

function requestReviewData(asin,website,linkReviewsUrl,i)
{
	//表示取消了
	if(total==0){
		return;
	}
	var url=website+linkReviewsUrl;
	$.ajax({
    type : "GET",
    url : url,
		success : function(html){
			proREviewData(html,asin,i);
			var has=$(html).find("[data-hook='pagination-bar']")
			// 限制只获取MAX_PAGE页评论
			if(has.length>0&&i<MAX_PAGE){
				var hasNext=$(has[0]).find(".a-last");
				if(hasNext.length>0){
					var nextUrl=$(hasNext[0]).find('a').attr("href");
					if(nextUrl){
						requestReviewData(asin,website,nextUrl,i+1)
					}else{
						requestNotify(url,asin,true,"");
					}
				}
			}else{
				requestNotify(url,asin,true,"");
			}
		}
		,
		error: function (xhr, status, error) {
		   requestNotify(url,asin,false,error);
		}
	});
}

function requestReviewDatas(asin,i,url)
{
	if(i != 1){
		url = "https://www.amazon.com"+url;
	}
	$.ajax({
    type : "GET",
    url : url,
		success : function(html){
			proREviewData(html,asin,i);
			var has=$(html).find("[data-hook='pagination-bar']")
			//i<5 限制只获取5页评论
			if(has.length>0&&i<MAX_PAGE){
				var hasNext=$(has[0]).find(".a-last");
				if(hasNext.length>0){
					var nextUrl=$(hasNext[0]).find('a').attr("href");
					if(nextUrl){
						requestReviewDatas(asin,i+1,nextUrl)
					}
				}
			}
		},
		error: function (xhr, status, error) {
		   requestNotify(url,asin,false,error);
		}
	});
}

function proREviewData(html,asin,i){
	var reviewDoc=$(html)
	//获取评论列表
	var reviewDiv=reviewDoc.find("[data-hook='review']")
	if(reviewDiv == null || reviewDiv == ""){
		return;
	}
	if(i==1){
		p={};
		var productLink=reviewDoc.find("[data-hook='product-link']");
		if(productLink.length>0){
		  p["productUrl"]=$(productLink[0]).attr("href");
		  p["asin"]=asin;
		  p["productName"]=(productLink[0]).outerText;
		  var productLink=reviewDoc.find("[data-hook='cr-filter-info-review-rating-count']");
		  p["reviewNum"]=productLink[0].outerText;
		  p["reviews"]=[];
		  result.push(p);
		}
	}

	reviewDiv.each(function(i,r){
		
		var obj={};
		//评论人
		obj["profileName"]=$(r).find(".a-profile-name")[0].innerText;
		//获取评分
		obj["reviewStar"]=$(r).find(".a-icon-alt")[0].innerText;
		//评论标题
		obj["reviewTitle"]=$(r).find("[data-hook='review-title']")[0].innerText;
		//获取评论地址和日期，后面在拆分
		var rDate=$(r).find("[data-hook='review-date']"); 
		obj["reviewDate"]=rDate[0].innerText.split(' ')[0];
		obj["reviewIP"]=rDate[0].innerText.split(' ')[1];
		//获取评论颜色
		var rColor=$(r).find("[data-hook='format-strip']");
		obj["productUrlThis"]="";
		obj["asinThis"]="";
		if(rColor.length>0){
			obj["productUrlThis"]=rColor.attr('href');
			obj["asinThis"]=obj.productUrlThis.split('/')[4];
			obj["reviewColor"]=rColor[0].innerText;
		}else{
			obj["reviewColor"]="";
		}
		//获取评论内容
		var rBody=$(r).find("[data-hook='review-body']"); 
		obj["reviewBody"]=rBody[0].innerText;
		var rHelpful=$(r).find("[data-hook='helpful-vote-statement']"); 
		if(rHelpful.length>0)
			obj["helpfulText"]=rHelpful[0].innerText.trim();
		else
			obj["helpfulText"]="";
		
		var VP = $(r).find("[data-hook='linkless-format-strip-whats-this']");
		obj["reviewVp"]="";
		if(VP.length>0){
			obj["reviewVp"]="Y";
		}

		//评论图片
		var img = $(r).find("[data-action='a-modal']");
		obj["imgSum"] = 0;
		if(img.length > 0){
			obj["imgSum"]=img.length;
		}
		//评论视频
		var video = $(r).find("[class='vjs-poster']");
		obj["videoSum"]=0;
		if(video.length > 0){
			obj["videoSum"]=video.length;
		}

		addReviewObj(asin,obj);
	})
}


//翻译
function CH(text){
	var url="https://fanyi.baidu.com/#en/zh/"+text;
	var params=null;
	var data = {
			"from": "en",
			"to": "zh",
			"query": test,
			"simple_means_flag": "3",
			"sign": "589631.793614",
			"token": "1a9e783080d6af9166130b6bdf775c02",
			"domain": "common"
		}
	$.ajax({
	async:false, 
    type : "POST",
	data:data,
    url : url,
		success : function(html){
			var reviewDoc=$(html)
			var a = reviewDoc.find("[class='ordinary-output target-output clearfix']");
			alert(reviewDoc)
		}
	})
}

/*
 * 请求获取参数
 */
function getRequestParam(){
	var url=YZ_HTTP+"review/readExcelParam";
	var params=[];
	$.ajax({
	async:false, 
    type : "GET",
    url : url,
		success : function(result){
			params= result.data;
		}
	})
	return params;
}
/*
 * 请求获取地区
 */
function requestGetCountry(){
	var url=YZ_HTTP+"review/getCountry";
	var country=[];
	$.ajax({
	async:false, 
    type : "GET",
    url : url,
		success : function(result){
			country=result.data;
		}
	})
	return country;
}

/*
 * 请求抓取数据
 */
async function begin() {
	if(uuid==""){
		uuid=guid();
	}
	initResult();
	 //var param= await getRequestParam();
	 var param=asinList;
	 total=param.length;
	 var country=await requestGetCountry();
	 for( var p in param){
		 countryArray=country.filter(function(c){
			 return c.countryCode==param[p].country;
		 })
		if(countryArray.length>0){
			var asin=param[p].asin;
			var url=URL.format(asin);
			requestReviewData(asin,countryArray[0].url,url,1)
		}
	 }
}


/*
* 添加评论到集合
*/
function addReviewObj(asin,reviewObj){
	var product=result.filter(function(r){return r.asin==asin});
	if(product.length>0){
		var reviews=product[0]["reviews"];
		reviews.push(reviewObj);
	}
}

/*
* 初始并添加产品信息
*/
function initAndProduct(asin,reviewDoc){
	var productLink=reviewDoc.find("[data-hook='product-link']");
	if(productLink.length>0){
	  p={};
	  p["productUrl"]=$(productLink[0]).attr("href");
	  p["asin"]=asin;
	  p["productName"]=(productLink[0]).outerText;
	  var productLink=reviewDoc.find("[data-hook='cr-filter-info-review-rating-count']");
	  p["reviewNum"]=productLink[0].outerText;
	  p["reviews"]=[];
	  result.push(p);
	}
}
/*
* 初始化计数
*/
function initResult(){
	total=0;
	process=0;
	result=[];
}

function getResult(){
	var r={};
	r["total"]=total;
	r["process"]=process;
	r["result"]=result;
    r["uuid"]=uuid;
	return r;
}

/*
 * 格式化字符串方式
 */
String.prototype.format = function(args) {
        var result = this;
        if (arguments.length > 0) {
            if (arguments.length == 1 && typeof (args) == "object") {
                for (var key in args) {
                    if(args[key]!=undefined){
                        var reg = new RegExp("({" + key + "})", "g");
                        result = result.replace(reg, args[key]);
                    }
                }
            }
            else {
                for (var i = 0; i < arguments.length; i++) {
                    if (arguments[i] != undefined) {
                        var reg= new RegExp("({)" + i + "(})", "g");
                        result = result.replace(reg, arguments[i]);
                    }
                }
            }
        }
        return result;
}

// Generate four random hex digits. 
function S4() { 
   return (((1+Math.random())*0x10000)|0).toString(16).substring(1); 
}; 
// Generate a pseudo-GUID by concatenating random hexadecimal. 
function guid() { 
   return (S4()+S4()+"-"+S4()+"-"+S4()+"-"+S4()+"-"+S4()+S4()+S4()); 
}; 
//get uuid
function getGuid(){
	//生成新的ID
	uuid=guid();
	return uuid;
}

//发消息
function sendMessageToPopup(msgType,msgSubject,msgContent){
	chrome.runtime.sendMessage({
		msg: msgType, 
		data: {
			subject: msgSubject,
			content: msgContent
		}
	});
}

//获取当前请求消
function getCurrentReqMsg(url,asin){
	msg="请求第{0}个,ASIN为{1}产品评论数据成功,URL:{2}".format(process,asin,url);
	return msg;
}
function getCurrentReqErrMsg(url,asin,error){
	msg="请求第{0}个,ASIN为{1}产品评论数据失败,URL:{2},原因:{3}".format(process,asin,url,error);
	return msg;
}

// true 成功  false 失败
function requestNotify(url,asin,flag,error){
	process=process+1;
	var r=getResult();
	if(flag)
		r["msg"]=getCurrentReqMsg(url,asin);
	else
		r["msg"]=getCurrentReqErrMsg(url,asin,error);
	sendMessageToPopup("process_msg","process",r);
	//获取成功，则保存
	if(total===process){
		finishSendData("null","a");
	}
}

/*
* 完成后发送数据给后端
*/
function finishSendData(uuidName,type,sendResponse){
	if(type=="s"){
		uuid = uuidName+"-评论-" + getNowDate();
	}else{
		uuid = result.asin+getNowDate();
	}
	$.ajax({
		url: YZ_HTTP+'chrome/amazonReviewFile?userNo='+userNo+'&reqId='+uuid, 
		type: 'POST',
		headers: {
			Authorization:usertoken
		},
		contentType: "application/json",
		data: JSON.stringify(result),
		success: function (response) {                        
			sendResponse({data:response});
			result = [];
		},
		error: function (xhr, status, error) {
			console.log("finishSendData error"+error);
			result = [];
		}
	});
}
function getNowDate() {
	var myDate = new Date;
	var year = myDate.getFullYear(); //获取当前年
	var mon = myDate.getMonth() + 1; //获取当前月
	var date = myDate.getDate(); //获取当前日
	var hours = myDate.getHours(); //获取当前小时
	var minutes = myDate.getMinutes(); //获取当前分钟
	var seconds = myDate.getSeconds(); //获取当前秒
	var now = year + "-" + mon + "-" + date + "_" + hours + "-" + minutes + "-" + seconds;
	return now;
}

//保存amazonListing文件
function productsDataExe(data,sendResponse){

	$.ajax({
		url: YZ_HTTP+'chrome/amazonListing',
		type: 'POST',
		headers: {
			Authorization:usertoken,
			contenType:"application/octet-stream;charset=utf-8"
		},
		contentType: "application/json",
		data: JSON.stringify(data),
		success: function (response) { 
			console.log(response );
			sendResponse({data:response });
		},
		error: function (xhr, status, error) {
			console.log("finishSendData error :"+error);
		}
	});
}

//验证码
function loginImg(sendResponse){
	$.ajax({
		url:YZ_HTTP+'captchaImage',
		type: 'get',
		timeout: 20000,
		success: function (data) {
			sendResponse({loginImg:data.img,uuid:data.uuid});
		}
	});
}

//获取短信、邮箱验证码
function getSmsCode(generalLoginReq){
	console.log(generalLoginReq)
	$.ajax({
		url: YZ_HTTP+'getSmsCode',
		type: 'POST',
		contentType: "application/json;charset=UTF-8",
		data:  JSON.stringify(generalLoginReq),
		success: function (datalogin) {
			
		}
	});
}

//验证码登录
function smsLogin(userdata,sendResponse){
	$.ajax({
		url: YZ_HTTP+'sms/login',
		type: 'post',
		headers: {
			isToken: false
		},
		contentType: "application/json;charset=UTF-8",
		data: JSON.stringify(userdata),
		success: function (datalogin) {
			if (datalogin.code == 200) {
				$.ajax({
					url: YZ_HTTP+'general/user',
					type: 'get',
					headers: {
						Authorization:datalogin.data
					},
					contentType: "application/json;charset=UTF-8",
					success: function (data) {
						if (data.code == 200) {
							YZ_USER = data.data
							userName = userdata.username;
							password = userdata.password;
							userNo = userdata.username;
							usertoken = datalogin.token;
							sendResponse({msg:0,data:data.data,page:28});
						} else {
							sendResponse({msg:data.msg});
						}
					}
				});
			
			} else {
				sendResponse({msg:datalogin.msg});
			}
		}
	});
}


//登录
function login(userdata,sendResponse){
	$.ajax({
		url: YZ_HTTP+'general/login',
		type: 'post',
		headers: {
			isToken: false
		},
		contentType: "application/json;charset=UTF-8",
		data: JSON.stringify(userdata),
		success: function (datalogin) {
			if (datalogin.code == 200) {
				$.ajax({
					url: YZ_HTTP+'general/user',
					type: 'get',
					headers: {
						Authorization:datalogin.data
					},
					contentType: "application/json;charset=UTF-8",
					success: function (data) {
						if (data.code == 200) {
							YZ_USER = data.data
							userName = userdata.username;
							password = userdata.password;
							userNo = userdata.username;
							usertoken = datalogin.data;
							sendResponse({msg:0,data:data.data,page:28});
						} else {
							sendResponse({msg:data.msg});
						}
					}
				});
			
			} else {
				sendResponse({msg:datalogin.msg});
			}
		}
	});
}


//注册·
function register(userdata,sendResponse){
	$.ajax({
		url: YZ_HTTP+'register',
		type: 'post',
		contentType: "application/json;charset=UTF-8",
		data: JSON.stringify(userdata),
		success: function (data) {
			if (data.code == 200) {
				sendResponse({msg:0});
			} else {
				sendResponse({msg:data.msg});
			}
		}
	});
}

//评论分词
function reviewParticiple(review,sendResponse){
	$.ajax({
		url: YZ_HTTP+'chrome/review',
		type: 'post',
		contentType: "application/json;charset=UTF-8",
		data: JSON.stringify(review),
		headers: {
			Authorization:usertoken
		},
		success: function (data) {
			if (data.data.length != 0) {
				sendResponse({msg:data.data});
			}else{
				sendResponse({msg:0});
			}
		}
	});
}

//市场分析
function Analysis(data){
	var da = {"data":JSON.stringify(data),"userid":YZ_USER.userId};
	$.ajax({
		url:YZ_HTTP+'chrome/saveData',
		type: 'post',
		dataType: 'json',
		headers: {
			Authorization:usertoken
		},
		data: da,
		success: function (data) {
			confirm(data.msg)
		}
	});
}


//接收消息
chrome.runtime.onMessage.addListener(
	function(request, sender, sendResponse) {	

		if (request.type == 'logOut') {
			userNo = "";
			userName = "";
			password = "";
			var token = usertoken;
			var tokendata = { "token": token };
			usertoken = ""
			window.location.reload();
			$.ajax({
				url: YZ_HTTP + 'logout',
				type: 'post',
				data: { "token": token },
				contentType: "application/x-www-form-urlencoded",
				success: function (data) {
					if (data.code == 200) {
						displayLogin();
					} else {
						alert(data.msg)
					}
				}
			});
		}

		if ( request.type == 'getChromeId' ){
				sendResponse({ chromeId: sender.id});
		}			

		if(request.type =="YZ_Analysis"){
			Analysis(request.reviews);
			sendResponse({flag: true})
		}

		if(request.type =="islogin"){
			if(userNo==""){
				sendResponse({isLogin: 0})
			}else{
				sendResponse({isLogin: 1})
			}
		}
	//获取单个商品评论数据	
	if (request.type == "productReview"){
			var url=request.url;
			var asin=request.asin;
			var host=request.host;
			uuid=getGuid();
			initResult();
			total=1;
			requestReviewData(asin,host,url,1)
	}
	if (request.type == "productReviews"){
		var asin=request.asin;
		var url="https://www.amazon.com/-/zh/product-reviews/"+asin+"/ref=cm_cr_arp_d_viewopt_srt?ie=UTF8&reviewerType=all_reviews&sortBy=recent&pageNumber=1";
		requestReviewDatas(asin,1,url)
	 }
	 if (request.type == "finishSendData"){
		uuid=getGuid();
		if(request.reviews != null && request.reviews != ""){
			result = request.reviews;
		}
		finishSendData(request.uuidName,"s",sendResponse);
	 }
	 if(request.type == "productsDataExe"){
		productsDataExe(request.result,sendResponse);
	 }
	 if(request.type == "code"){
		if(userNo==""){
			sendResponse({isLogin: 0})
		}else{
			sendResponse({isLogin: 1})
		}
	}
	if(request.type == "login"){
		login(request.userdata,sendResponse);
	}
	if(request.type == "smsLogin"){
		smsLogin(request.userdata,sendResponse);
	}
	if(request.type == "getloginImg"){
		loginImg(sendResponse);
	}
	if(request.type == "register"){
		register(request.userdata,sendResponse);
	}
	if(request.type== "getSmsCode"){
		getSmsCode(request.userdata);
	}
	if(request.type== "reviewParticiple"){
		reviewParticiple(request.review,sendResponse);
	}
	return true;
});
